/* @(#) cgksincl.h  version:1.8  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.cgksincl.h
 * SCCS id :	cgksincl.h 1.8
 * Last edited:	11/9/84 14:17:57
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 * This file contains the inclusions defines necessary to include
 * all the headers files. Allthough it is not decent to include
 * include-files via an included file,
 * using only one statement:
 * #include "cgksincl.h" or
 * #include <cgksincl.h> 
 * (or whatever you need)
 * is much more convenient for the programmer to deal with,
 * than including all the files seperately.
 */

#include "cgkslevel.h"
#include "cgkslocal.h"

#include <stdio.h>

#include "cgks.h"

#include "cgksmeta.h"
#ifdef METAFILE
#include "cgksmfmacs.h"
#include "cgksmfit.h"
#endif

#include "cgksconst.h"
#include "cgksmacs.h"
#include "cgksfun.h"
#include "cgksfhead.h"
#include "cgkspaths.h"
#include "cgkswstypes.h"
