/* @(#) cgksmacs.h  version:1.9  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.cgksmacs.h
 * SCCS id :	cgksmacs.h 1.9
 * Last edited:	11/12/84 10:24:41
 */

#define	Ch_State(ERR_NO, FUN) \
	if (ch_state(ERR_NO, FUN) != 0) GKS_RETURN(ERR_NO)

#define	GKS_RETURN(I) \
	{ gksfun_ret(); return(I); }

#define WS_ER_OFF 41 /*for error numbers 42 up to 50 see cgks manual*/
#define	Ch_Er_Ws(WS, ERR_NO, FUN) \
	if (ch_er_ws(WS, ERR_NO, FUN) != 0) return(WS_ER_OFF + ERR_NO)

#define Rep_Er(ERR_NO, FUN) \
	{ rep_er(ERR_NO, FUN); return(ERR_NO); }

#define IsntRect(REC)  isntrect((Real *)REC)

#if (GKS == 4 || GKS == 6)
#define IsntRange(R1, R2) isntrange((Real *)R1, (Real *)R2)
#endif

#ifdef GKS2
#define Concat(NR, WIND1, WIND2)\
	concat((Real *)NR, (Real *)WIND1, (Real *)WIND2);
#endif

/*see in cgkslocal.h if STRUCTASS is defined */

#ifdef STRUCTASS
#define ASS(a, b) a = b;
#else
#define	ASS(a, b) \
	{	char *aptr, *bptr; \
		int n; \
		n = sizeof(a);\
		aptr = (char *)&a; bptr = (char *)&b;\
		while (n--) {\
			*aptr = *bptr; \
			aptr++; bptr++;\
		}\
	}
#endif

#define MARK(TYP, CH_ST_TR)  attmark[TYP] |= CH_ST_TR;
#define CLMARK(TYP)  attmark[TYP] = ID;

#define WsScrn	ws->ws_wsd->wd_screen
#define SetScr(ws, scr) scr = WsScrn;

#ifndef MALL_DBG
#define MALLOC(VAR, TYPE, SIZE, FUN)   \
	if ((VAR = (TYPE *)malloc(SIZE)) == NULL) rep_er(301, FUN);

#define CALLOC(VAR, TYPE, NR, FUN)  \
	if ((VAR = (TYPE *)calloc(NR, sizeof(TYPE))) == NULL) \
		rep_er(301, FUN); 

#define REALLOC(VAR, TYPE, NR, FUN)   \
	if ((VAR = (TYPE *)realloc((char *)VAR, (NR) * sizeof(TYPE))) \
			== NULL) rep_er(301, FUN);

#define FREE(VAR)  if (VAR != NULL) free((char *)VAR); 

#else
#define MALLOC(VAR, TYPE, SIZE, FUN)  {  \
	if ((VAR = (TYPE *)malloc(SIZE)) == NULL)  \
		rep_er(301, FUN);\
	mad_add((Int)VAR, FUN);\
	}

#define CALLOC(VAR, TYPE, NR, FUN) {  \
	if ((VAR = (TYPE *)calloc(NR, sizeof(TYPE))) == NULL) \
		rep_er(301, FUN); \
	mad_add((Int)VAR, FUN);\
	}

#define REALLOC(VAR, TYPE, NR, FUN)  {  \
	mad_del((Int)VAR, FUN); \
	if ((VAR = (TYPE *)realloc((char *)VAR, (NR) * sizeof(TYPE))) \
			== NULL) \
		rep_er(301, FUN);\
	mad_add((Int)VAR, FUN);\
	}

#define FREE(VAR)   \
	  	if (VAR != NULL) { \
			extern Int _gksfun;\
			free((char *)VAR); \
			mad_del((Int)VAR, _gksfun); \
		}
#endif

#define TRANS(IMAT, X1, Y1, X2, Y2) \
	X2 = IMAT[0][0] * X1 + IMAT[0][1] * Y1 + IMAT[0][2];  \
	Y2 = IMAT[1][0] * X1 + IMAT[1][1] * Y1 + IMAT[1][2];  

