/* @(#) cgksmfmacs.h  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.cgksmfmacs.h
 * SCCS id :	cgksmfmacs.h 1.5
 * Last edited:	10/30/84 08:06:08
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define MFF_LOCAL	0
#define MFF_F77		1
#define MFF_TEST	2

#define MF_FORMAT	MFF_F77

#define MfScrn ws->ws_wsd->wd_mfscrn
#define SetMfSc(ws,mfscr) mfscr = MfScrn;


/* macro to write a current primitive attribute to the
	metafile output */

#define MF_ATTENSURE(MFFIELD,GKFIELD)\
{	Int i;\
	Wss	*ws;\
	for (i=0; i<gksd->gd_nopws; i++)\
		if ((ws = _gkss->gk_actv[i]) != NULL &&\
			(ws->ws_wsd->wd_cat == MO))\
			(*MfScrn->MFFIELD)(ws,_gkss->GKFIELD);\
}


#define MF_GEOMATT(MFFIELD,GKIFIELD)\
{	Int i;\
	Wss	*ws;\
	for (i=0; i<gksd->gd_nopws; i++)\
		if ((ws = _gkss->gk_actv[i]) != NULL &&\
			(ws->ws_wsd->wd_cat == MO))\
			(*MfScrn->MFFIELD)(ws,gksis->GKIFIELD);\
}


/* macro to write a current segment attribute to the
	metafile output */

#define MF_SGATTENS(MFFIELD,SEGM,ATT)\
{	Int i;\
	Wss	*ws;\
	for (i=0; i<gksd->gd_nwsas; i++)\
		if ((ws = SEGM->sg_onws[i]) != NULL &&\
			(ws->ws_wsd->wd_cat == MO))\
			(*MfScrn->MFFIELD)(ws,SEGM->sg_sn,SEGM->ATT);\
}

/*
*	macros for writing/reading of metafiles
*/
#define RBYTE	ws->ws_wsis->wi_mfhdr->mfh_R
#define IBYTE	ws->ws_wsis->wi_mfhdr->mfh_I

#define Intf	ws->ws_wsis->wi_mfhdr->mfh_intf
#define Realf	ws->ws_wsis->wi_mfhdr->mfh_realf
#define Itmhf	ws->ws_wsis->wi_mfhdr->mfh_itmhf
#define Itmhdr	ws->ws_wsis->wi_mfhdr->mfh_itmhdr
#define HDRLEN 	ws->ws_wsis->wi_mfhdr->mfh_hdrlen

