#include "cgksincl.h"

	Gks	*gkss;
	Wss	*wss_aed;
	Wss	*wss_wis;
	Int 	n, i, k, number;
	Real	r,pi, th;
	Wc	*p1, *p2;
	AreaRep	fa;
	LineRep	lr;
	TextRep	tr;
	String	string;
	Tmat	segmat;
	Seg	*seg,*seg2;

	Drect	drect0  = {  40,   70, 470, 455};
	Wrect	wrect = {0.0, 0.0, 1.0, 1.0};
	Nrect	nrect2 = {0.0, 0.0, 1.0, 1.0};
	Colour	col, bg_col = {0.7, 0.7, 0.1}, 
		yellow 	  ={1.0, 1.0, 0.0},
		white_col ={1.0, 1.0, 0.8};


setdrect(ws, dr, llx, lly, urx, ury)
Wss	*ws;
Drect	*dr;
Real	llx, lly, urx, ury;
{
	Drect	maxsurf;

	ASS(maxsurf , ws->ws_wsd->wd_maxsurf)
	dr->d_ll.d_x = llx * maxsurf.d_ur.d_x / 511.0; 
	dr->d_ll.d_y = lly * maxsurf.d_ur.d_y / 482.0; 
	dr->d_ur.d_x = urx * maxsurf.d_ur.d_x / 511.0; 
	dr->d_ur.d_y = ury * maxsurf.d_ur.d_y / 482.0; 
}


set_pl_rect(wr, p1)
Wrect	*wr;
Wc	*p1;
{	p2 = p1;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ll.w_y; p2++;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ur.w_y; p2++;
	p2->w_x = wr->w_ur.w_x; p2->w_y = wr->w_ur.w_y; p2++;
	p2->w_x = wr->w_ur.w_x; p2->w_y = wr->w_ll.w_y; p2++;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ll.w_y;
}


main()
{
	gkss    = open_gks(NULL, NULL, NULL);
	wss_aed = open_ws(NULL, NULL, aed512);
	wss_wis = open_ws(NULL, NULL, wis);
	activate(wss_aed);
	activate(wss_wis);

	setdrect(wss_aed, &drect0, 40.0, 70.0, 470.0, 455.0);

	col_rep(wss_aed,   0, &bg_col);
	col_rep(wss_aed, 255, &white_col);
	col_rep(wss_aed, 254, &yellow);

	lr.lr_lt = SOLIDL;
	if (wss_aed->ws_wsd->wd_screen->s_colr) fa.fa_is = SOLID;
	else fa.fa_is = HOLLOW;

	number = 15; r = 15.0;

	pi = 3.141;
	for (i=1; i<250; i = i +1) {
		col.c_red  =(sin(2*i*pi/255.0       )+1.0)/2.0;
		col.c_green=(sin(2*i*pi/255.0+2*pi/3)+1.0)/2.0;
		col.c_blue =(sin(2*i*pi/255.0+4*pi/3)+1.0)/2.0;
	     	col_rep(wss_aed, i, &col);

	     	lr.lr_ci = i; 
	     	lr.lr_ix =  i ; pl_rep(wss_aed, &lr);
	     	fa.fa_ci = i;
	     	fa.fa_ix =  i ; fa_rep(wss_aed, &fa);
	}

	s_pl_i(5);

	s_w_view(wss_aed, &drect0);
	update(wss_aed, TRUE);

	n = 200;
	CALLOC(p1, Wc, n, 0)

	s_window  (gkss->gk_ntran[3], &wrect);
	s_viewport(gkss->gk_ntran[3], &nrect2);
	sel_cntran(gkss->gk_ntran[3]);

	set_pl_rect(&wrect, p1);
	s_pl_i(12);
	polyline(5, p1);

	deactivate(wss_aed);
	seg = newseg(1);
	design(&wrect);
	closeg();
	activate(wss_aed);

	p2 = p1; p2->w_x = 0.0; p2->w_y = 0.0;
	p2++;    p2->w_x = 1.0; p2->w_y = 0.0;
	p2++;    p2->w_x = 1.0; p2->w_y = 0.06;
	p2++;    p2->w_x = 0.0; p2->w_y = 0.06;
	p2++;    p2->w_x = 0.0; p2->w_y = 0.0;

	s_fa_i(6);
	fillarea(4, p1);

	string = "Test for wiss and segm trafos; polyline only in wiss";
	p1->w_x = 0.03;
	p1->w_y = 0.024;
	s_ch_ht(0.03);
	tr.tx_ci = 40;
	tr.tx_chef = 1.0;
	tr.tx_ix = 2;
	tr.tx_fp.fp_fo = 2;
	tr.tx_fp.fp_pr = STR;
	tr.tx_ix =  2 ; tx_rep(wss_aed,&tr);
	s_tx_i(2);
	text(string, p1);

	redraw(wss_aed);
	string = " redraw segments on Aed called";
	text(string, p1);

	sendseg(wss_aed, seg);

	th = 0.4;
	segmat[0][0] = cos(th);  
	segmat[0][1] = 2.9 * sin(th);
	segmat[0][2] = -th;
	segmat[1][0] = -sin(th); 	
	segmat[1][1] = cos(th); 
	segmat[1][2] = 0.0;
	transeg(seg, &segmat[0][0]);
	redraw(wss_aed);
	text(string, p1);

	deactivate(wss_aed);
	deactivate(wss_wis);
	close_ws(wss_aed);
	close_ws(wss_wis);
	close_gks();
}

design( wrect)
Wrect	*wrect;
{
	Wc	M, *p2, p1[100];
	Real	arg,R, pi, alpha;
	Int 	nr;
	Real	nrr;
	s_pl_i(170);
	p2 = p1;p2->w_x=(wrect->w_ur.w_x + wrect->w_ll.w_x)/ 2.0;
	        p2->w_y=(wrect->w_ll.w_y) ;
	p2++   ;p2->w_x=(wrect->w_ur.w_x + wrect->w_ll.w_x)/ 2.0;
	        p2->w_y=(wrect->w_ur.w_y);
	polyline(2, p1);

	p2 = p1;p2->w_y=(wrect->w_ur.w_y + wrect->w_ll.w_y)/ 2.0;
	        p2->w_x=(wrect->w_ll.w_x);
	p2++   ;p2->w_y=(wrect->w_ur.w_y + wrect->w_ll.w_y)/ 2.0;
	        p2->w_x=(wrect->w_ur.w_x);
	polyline(2, p1);

	set_pl_rect(wrect, p1);
	polyline(5, p1);

	s_pl_i(70);
	M.w_x = (wrect->w_ur.w_x + wrect->w_ll.w_x)/ 2.0 ;
	M.w_y = (wrect->w_ur.w_y + wrect->w_ll.w_y)/ 2.0 ;
	R = 0.4;
	nr = 96;
	nrr = nr;
	pi = acos(0.0) * 2.0;
	alpha = pi * (nr-2) / nrr;
	p2 = p1;
	for (i = 0; i<= nr; i++) {
		arg = i * alpha;
		p2->w_x = M.w_x + R * sin(arg);
		p2->w_y = M.w_y + R * cos(arg);
		p2++;
	};
	polyline(nr + 1,p1);
}
