/* @(#) acc_trmat.c  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.acc_trmat.c
 * SCCS id :	acc_trmat.c 1.4
 * Last edited:	10/19/84 14:11:11
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 9
#define GKS9

#include "cgksincl.h"

Tmat *
acc_trmat(segmat, p, shift, rot, scale, wcoord)
Tmat	*segmat;
Real	*p;
Real	*shift;
Real	rot;
Real	*scale; 
Bool	wcoord; /*TRUE if WC coordinates, FALSE if NDC coordinates*/
{
	Tmat *tmat;
	Real *rptr;
	Nc   np, nshift;

	if (ch_state(8, ACC_TRMAT) != 0) return(NULL);
	MALLOC(tmat, Tmat, sizeof(Tmat), ACC_TRMAT)

	if (wcoord == TRUE) {
		ensure(ACC_TRMAT);
		ntransf((Wc *)p, &np);
		ntransf((Wc *)shift, &nshift);
	}
	else {	ASS(np, *((Nc *)p))
		ASS(nshift, *((Nc *)shift))
	}



	return(tmat);
}
