/* @(#) aedatt.h  version:1.4  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.aedatt.h
 * SCCS id :	aedatt.h 1.4
 * Last edited:	10/19/84 14:10:09
 */

static Ltype	curltype  = 0;

/*
 * Set Line Attributes
 */
STATIC
Bool
setlatt(ws, lrep)
Wss	*ws;
LineRep	lrep;
{
	setltyp(lrep.lr_lt);
	setcol(ws, lrep.lr_ci);
}

/*
 * Set Line Type
 */
STATIC
setltyp(l)
Ltype	l;
{
	if (l == curltype)
		return;
	prefix(ESC);
	command(AedSLS);
	switch (l) {
	case DOTTED:
		value8((Int)dotted);
		break;
	case DASHED:
		value8((Int)dashed);
		break;
	case DOTDASH:
		value8((Int)dotdash);
		break;
	default:
		value8('\377');
		break;
	}
	value8(AedScl4);

	curltype = l;
}

STATIC 
Bool	
setmatt(ws, mrep)
Wss	*ws;
MarkRep	mrep;
{
	setltyp(SOLIDL);
	setcol(ws, mrep.mr_ci);
}

STATIC 
Bool	
settatt(ws, trep/*, and other attributes*/)
Wss	*ws;
TextRep	trep;
{
	setcol(ws, trep.tx_ci);
}

STATIC 
Bool	
setfatt(ws, frep)
Wss	*ws;
AreaRep	frep;
{
	if (frep.fa_is == HOLLOW) setltyp(SOLIDL);
	setcol(ws, frep.fa_ci);
}

/*
 *select colour
 */
STATIC
Bool
setcol(ws,c)
Wss	*ws;
Cindex	c;
{	Screen *sc = WsScrn;
	Set_Out(ws->ws_ofile)
	if (c != sc->s_ccol) {
		alphamode();
		prefix(ESC);
		command(AedSEC);
		value8((Int)c);
		sc->s_ccol = c;
	}
}

/*
 *set colour table
 */
STATIC
Bool setcolt(ws, colp)
Wss	*ws;
register Colour	*colp;
{	register Int n =256;
	register Real	*rgb;

	Set_Out(ws->ws_ofile)
#if	(TRMTYP==512)
	alphamode();
	prefix(ESC);
	command(AedSCT);
	value8(0);
	value8(n);
	rgb = &(colp->c_red);
	while (n--) {
		value8((Int)(255.0 * *rgb++));
		value8((Int)(255.0 * *rgb++));
		value8((Int)(255.0 * *rgb++));
	}
#endif
}
