/* @(#) aedcel.h  version:1.10  dated:84/11/21 */
/*
 * SCCS file:	SCCS/s.aedcel.h
 * SCCS id :	aedcel.h 1.10
 * Last edited:	11/21/84 14:34:27
 */

/*This file contains driver functions and driver utility functions
 *for the AED concerning cellarray facilities*/

/*******CELLS**********************/

STATIC
Bool
cells(ws, ul, n, m, ccols)
Wss	*ws;
Ic	*ul;
Size	n, m;
Cindex	*ccols;	/* n*m colours */
{
	Ic lr;
	register Int nr, i;
	register Cindex *ci;
	Cindex	sendcol;

	Set_Out(ws->ws_ofile)
	if ((n * m) == 0) return(FALSE);

	lr.i_x = ul->i_x + n - 1;
	lr.i_y = ul->i_y - m + 1;

	if (atbeam(ul) == FALSE || graphmode == FALSE)
		moveto(ul);
	prefix(ESC);
	command(AedDAI);
	abscoord(&lr);
	ci = ccols;
	sendcol = *ci++;
	i = n * m - 1;
	nr = 1;
	command(AedWHR);
	/*the aed512 can't handle here operands > 255  (?!)*/
	while (i-- != 0){
		if (*ci != sendcol || nr == 255) {
			/*because nr < 255, nr fits in one byte:*/
			value8(nr);
			value8(sendcol);
			nr = 1;
			sendcol = *ci;
		}
		else nr++;

		ci++;
	}
	if (nr != 0) {
		value8(nr);
		value8(sendcol);
	}
	value8(0);
	return(TRUE);
}
