/* @(#) aedesc.h  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.aedesc.h
 * SCCS id :	aedesc.h 1.4
 * Last edited:	11/13/84 01:19:34
 *
 * Author:	Frank van Steenbrugge
 *		Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */
/*
 * This file contains driver functions and driver utility functions
 * for the escape function for the aed512
 */

STATIC
Bool
aedescape(ws, ef, ep)
Wss *ws;
Es_func	ef;
Es_data *ep;
{	
	Set_Out(ws->ws_ofile);
	Set_In (ws->ws_ifile);
	switch (ef) {
	case ES_SELWBPL:
		setwritemask(ep->sbm_rec.sbm_wbitmask);
		break;
	case ES_TRANSPARENT:
		/*
		settransp(ep->trp_rec.trp_onoff);
		*/
		break;
	default:
	break;
	}
}

/* SELECTIVE BITPLANE WRITE*******************************************/
/*
 * With the escape function ES_SELWBPL a write mask can be sent to
 * the driver, indicating which bitplanes will be written, and
 * which can't.
 * This setting is done in setwritemask().
 * If there is a 1 for a bitplane that plane may be written.
 * The lowest most right bit corresponds to the first bitplane.
 */

/*
 * initially writes are possible on all bitplanes :
 * ( also default device setting)
 */
STATIC short aed_w_mask = 0677;

setwritemask(newmask)
short newmask;
{
	if (aed_w_mask != newmask) {
		prefix(ESC);
		command(AedSWM);
		value8(newmask);

		aed_w_mask = newmask;
	}

}


/* TO DO :  (doesn't work yet)*/
/* TRANSPARANCY************************************************/
/*
 * With the escape function ES_TRANSPARENT one can indicate
 * whether or not the bitplanes are to written transparent.
 * If transp_onoff is 0/1, transparency is set on/off.
 * "Transparency on" means that the ones of the colourindex to be
 * used are written in the bitplanes on the proper places.
 * but the nills are not written at all, so no ones are
 * faded on places in the bitplanes where otherwise 
 * a 0 should be written.
 * The function is implemented with the Boolean transparency.
 */


static short transparency = 0;

settransp(onoff)
short onoff;
{
	transparency = onoff;
}

/*
selbp( ib, colour, yb )
register int ib, colour, *yb;
{
	register int mode;

	if(!(bitmask & bp[ib].ibmask) ||
	   (!(colour & bp[ib].ibmask) && transparency))
		return (-1);
		/* no write in this bitplane */ /*
	else if (colour & bp[ib].ibmask)
		mode = RMW_SET;
	else
		mode = RMW_RES;

	g   = bp[ib].g;
	*yb = bp[ib].ybase;

	return( mode );
}
*/
