/* @(#) aedhinp.h  version:1.3  dated:84/10/19 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.aedhinp.h
 * SCCS id :	aedhinp.h 1.3
 * Last edited:	10/19/84 12:37:01
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 * this file contains high level input functions
 * oriented towards GKS
 */

/*
 * initialize locator or valuator or etc. input device
 */
STATIC 
Bool	
aedidevice(ws, iclass, devno, val, pet, earea, drec); 
Wss	*ws;
Iclass	iclass;
Devno	devno;
Value	*val;
Pet	pet;
Drect	*earea;
Drecord	*drec;
{
}

/*
 * set locator or valuator or etc. input device mode
 */
STATIC 
Bool	
aedimode(ws, iclass, devno, imode, echo)
Wss	*ws;
Iclass	iclass;
Devno	devno;
Imode	imode; /*REQUEST, SAMPLE or EVENT*/
Bool	echo;
{
}

/*get aed512 req. or sample input from loc dev */
STATIC
Bool
aedlocator(ws, devno, imode, val)
Wss	*ws;
Devno	devno;
Imode	imode; /* REQUEST or SAMPE*/
Value	*val;
{
}

/*get aed512 req. or sample input from val dev */
STATIC
Bool
aedvaluator(ws, devno, imode, val)
Wss	*ws;
Devno	devno;
Imode	imode; /* REQUEST or SAMPE*/
Value	*val;
{
}

/*get aed512 req. or sample input from cho dev */
STATIC
Bool
aedchoice(ws, devno, imode, val)
Wss	*ws;
Devno	devno;
Imode	imode; /* REQUEST or SAMPE*/
Value	*val;
{
}

/*get aed512 req. or sample input from str dev */
STATIC
Bool
aedstring(ws, devno, imode, val)
Wss	*ws;
Devno	devno;
Imode	imode; /* REQUEST or SAMPE*/
Value	*val;
{
}

/*get aed512 req. or sample input from stke dev */
STATIC
Bool
aedstroke(ws, devno, imode, val)
Wss	*ws;
Devno	devno;
Imode	imode; /* REQUEST or SAMPE*/
Value	*val;
{
}

/*get aed512 req. or sample input from pick dev */
STATIC
Bool
aedpick(ws, devno, imode, val)
Wss	*ws;
Devno	devno;
Imode	imode; /* REQUEST or SAMPE*/
Value	*val;
{
}
