/* @(#) aedinp.h  version:1.11  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.aedinp.h
 * SCCS id :	aedinp.h 1.11
 * Last edited:	11/13/84 23:49:10
 *
 * Author:	David Rosenthal, Frank Steenbrugge,
		Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define ESC_RUBBERBAND

#undef	getchar

extern int	errno;
static jmp_buf	Quit;

STATIC int
getchar()
{
	register int	c;

	c = fgetc(AedIN);
	if (c == EOF /* && errno == EINTR*/) {
		longjmp(Quit,-1);
	}
	else {
#ifdef	CREAT_INP
		if (aedinpfp != NULL) fprintf(aedinpfp,"%c",c);
#endif
		return(c);
	}
}



static int
catchit(sig)
{
}

static int
ctchintr(sig)
{
	longjmp(Quit, -1);
}

STATIC int
keyboard(ws, s, hit)
Wss	*ws;
Ic	*s, *hit;
{	register int	ch;
	Screen	*sc = WsScrn;
	int	(*fintr)();

	Set_In(ws->ws_ifile)
	Set_Out(ws->ws_ofile)
	if (setjmp(Quit) != 0) {
		return('\0');
	}
	moveto(hit);

	alphamode();
	fintr = signal(SIGINT, ctchintr);
	ch = getchar() & MASK7;
	signal(SIGINT, fintr);
	s->i_x = sc->s_size.i_x/2;
	s->i_y = sc->s_size.i_y/2;
	return (ch);
}

STATIC
s_pet(pet)
Pet pet;
{
	if ( pet == curpet) return;
	prefix(ESC);
	command(AedSCP);
	switch (pet) {
	case 2: /*pet 2 is crosshair */
		putchar('L');
		value8(0);
		value8(2);
		/*pixels written in colour 2  disappear (!?) */
		/*when touched with this crosshair */
		break;
	case 1: /*pet 1 is small cross */
	default:
		putchar('X');
		value8(0);
		value8(1);
		break;
	}
}

/*
 * Do a Cursor Interaction
 */
STATIC int
cursor(ws, s, pet, locate)
Wss	*ws;
Ic	*s;
Pet	pet;
Locate	*locate;
{
	register int	ch;

	Set_In (ws->ws_ifile)
	Set_Out(ws->ws_ofile)

	switch (pet) {
	case 1:
	case 2:
	default:
		ch = hardcursor(ws, s, pet);
		break;

	case 4:
	case 5:
#ifdef ESC_RUBBERBAND
		ch = softcursor(ws, s, pet, locate);
#endif
		break;
	}

	return(ch);
}

/* get input from aed.
 * cursor is one of the devices cursors.
 * the system is hang up in this function until the trigger is fired.
 */
STATIC
int hardcursor(ws, s, pet)
Wss	*ws;
Ic	*s;
Pet	pet;
{
	register int	i, ch;
	Ic	t;
	Screen	*sc = WsScrn;
	int	(*fintr)();
#if	(CODE == 1)
	char	resp[16], *cp;
#endif
	if (pet != 0) s_pet(pet);

	if (setjmp(Quit) != 0) {
		/* following code is executed after a longjmp()
		 * from either getchar() or ctchintr()
		 */
		signal(SIGALRM,SIG_IGN);
		prefix(ESC);
		command(AedDJC);
		prefix(ESC);
		command(AedECU);
		alphamode();
#if	(CODE == 7 || CODE == 8)
		aedttyb.sg_flags &= ~RAW;
		ioctl(fileno(AedOUT),TIOCSETP,&aedttyb);
#endif
		if (sc->s_timo != 0) {
			ASS(*s , sc->s_hit)
			return(sc->s_code);
		}
		else {
			 /* if (errno == EINTR)*/ return('\0');
		}
	}

	while(TRUE) {
		alphamode();
		prefix(ESC);
		command(AedEJC);
		flush(CURSED);
		if (sc->s_timo != 0) {
			signal(SIGALRM,catchit);
			alarm(sc->s_timo);
		}
		fintr = signal(SIGINT, ctchintr);
		/* if char is brk/interrupt than char is caught,
		 */
		ch = getchar() & MASK7;
		signal(SIGINT, fintr);
		signal(SIGALRM,SIG_IGN);

#if	(CODE == 7 || CODE == 8)
		aedttyb.sg_flags |= RAW;
		ioctl(fileno(AedOUT),TIOCSETP,&aedttyb);
#endif
		command(AedDJC);
		command(AedRCP);
		flush(CURSED);
		alphamode();
#if	(CODE == 7)
		i = getchar();
		t.i_x = (i & 0160) << 3;
		t.i_y = (i & 017) << 7;
		t.i_x |= getchar() & MASK7;
		t.i_y |= getchar() & MASK7;
#endif
#if	(CODE == 8)
		i = getchar();
		t.i_x = (i & 0340) << 4;
		t.i_y = (i & 037) << 8;
		t.i_x |= getchar();
		t.i_y |= getchar();
#endif
#if	(CODE == 7 || CODE == 8)
		aedttyb.sg_flags &= ~RAW;
		ioctl(fileno(AedOUT),TIOCSETP,&aedttyb);
		prefix(ESC);
		command(AedECU);
		prefix(ESC);
		command(AedSCR);
		alphamode();
#endif
#if	(CODE == 1)
		prefix(ESC);
		command(AedECU);
		cp = resp;
		i = 2;
		while (i > 0 && cp < &resp[14]) {
			*cp = getchar();
			if (!isdigit(*cp))
				i--;
			cp++;
		}
		*cp = '\0';
		prefix(ESC);
		command(AedSCR);
		while (getchar() != '\n')
			;
		if (sscanf(resp,"%d%d",&(t.i_x),&(t.i_y)) >= 2){

#else
		if ((getchar() & MASK7) == '\n') {
#endif
			ASS(*s , t)
			ASS(sc->s_hit , *s)
			sc->s_code = ch;
			return(ch);
		}
#if	(CODE == 7 || CODE == 8)
		else {
			while((getchar() & MASK7) != '\n')
					;
		}
#endif
	}
}


#ifdef ESC_RUBBERBAND

/*****soft cursor*****************/

/*
 * A rubber_band cursor, generated in software, needs a bitplane
 * for writing and whiping out the cursor. 
 * In the following code for the aed512 bitplane 8 is used
 * for this purpose.
 * This includes that the application can only use 7 bitplanes
 * to select a colour (bitplane 0 - 6).
 *
 * A proper break facility, using the break key, will be added.
 * At this moment a character 'q' is interpreted as the GKS 'break'.
 * Allthough the break key is ignored during the function
 * readcursor() the state after using this key is unpredictable .
 */

#define BRK_RUBBERB 'q'

STATIC
Bool
readcursor(x, y, trigger)
int *x, *y;
char 	*trigger;
{
	int	i = 2;
	Bool	ret = FALSE;
#if	(CODE == 1)
	register char *cp;
	char	resp[16];

	prefix(ESC);
	command(AedEJC);

	command(AedRCP);/*aed sends 2 ints, each ended with nl char*/
	cp = resp;

	while (i > 0 && cp < &resp[14]) {
		*cp = getchar();
		if (!isdigit(*cp)) {
			if (*cp == '\n') {
				i--;
			}
			else {
				*trigger = *cp;
				ret = TRUE;
				continue;
			}
		}
		cp++;
	}
	*cp = '\0';
	sscanf(resp,"%d%d", x, y);

	command(AedDJC);

#endif
	return(ret);
}

STATIC
int 
softcursor( ws, s, pet, locate ) 
Wss	*ws;
Ic	*s;	/* s points to initial locator position transformed to
		 * Ic via norm. transf. locate->loc_nt
		 */
Pet	pet;
Locate	*locate; 
{
	register int	inx, iny;
		/*initial (x, y) from where band is drawn */
	register int	xold, yold;
	int	xaed, yaed;
	Screen 	*sc = WsScrn;
	int 	oldmask = aed_w_mask;
	Cindex	oldcol;
	char	trig;
	int (*fintr)();

	setwritemask(0200);

	oldcol = sc->s_ccol;
	/*set a colour that uses 8th bitplane: */
	prefix(ESC);
	command(AedSEC);
	value8(255);

	/* to be able to read the cursor position, the cursor has
	 * to be enabled. Unfortunately this causes an Aed cursor
	 * to appear on the screen. Therefore draw this cursor
	 * in background color :
	 */
	command(AedSCC);
	value8(0);
	value8(0);
	value8(0);

	fintr = signal(SIGINT, SIG_IGN);
	readcursor(&xaed, &yaed, &trig);
	xold = xaed;
	yold = yaed;

	/* draw a line to (xaed,yaed) in bitplane 8.
 	 * Bitplane 8 is used for rubber lines etc. 
 	 */
	inx = s->i_x;
	iny = s->i_y;	

	switch (pet) {
	case (4): /* rubber band line */
		line_in_8(ws, inx, iny, xaed, yaed, TRUE);
		break;
	case (5): /* rubber rectangle */
		rect_in_8(ws, inx, iny, xaed, yaed, TRUE);
		break;
	default:
		break;
	}

	for (;;) {
	   /* if necessary draw new rubber line: */
	   if ((xaed != xold) || (yaed != yold)) {
		switch (pet) {
		case (4):
			/* wipe out previous rubber line_in_8 */
			line_in_8(ws, inx, iny, xold, yold, FALSE);
			/* draw new rubber line_in_8 */
			line_in_8(ws, inx, iny, xaed, yaed, TRUE);
			break;
		case (5):
			/* wipe out old rectangle */
			rect_in_8(ws, inx, iny, xold, yold, FALSE);
			/* draw new rectangle */
			rect_in_8(ws, inx, iny, xaed, yaed, TRUE);
			break;
		default:
			break;
		}

		xold = xaed;
		yold = yaed;
	   }
	   if (readcursor(&xaed, &yaed, &trig) == TRUE)
		break;
	}
	signal(SIGINT, fintr);

	/* set cursor colour back to 2 (default aed cursor colour) */
	/* (actually this colour has to be a global parameter) */
	prefix(ESC);
	command(AedSCC);
	value8(2);
	value8(2);
	value8(0);

	switch (pet) {
	case (4): /* wipe out last rubber line*/
		line_in_8(ws,inx, iny, xold, yold, FALSE);
		if (xaed != xold || yaed != yold) {
		/*draw the line to show a short time the last position*/
			line_in_8(ws, inx, iny, xaed, yaed, TRUE);
			line_in_8(ws, inx, iny, xaed, yaed, FALSE);
		}
		break;
	case (5): /* wipe out last rectangle */
		rect_in_8(ws, inx, iny, xold, yold, FALSE);
		break;
	default:
		break;
	}

	setwritemask(0377);

	/* reinstall old drawing colour: */
	alphamode();
	prefix(ESC);
	command(AedSEC);
	value8((Int)oldcol);
	WsScrn->s_ccol = oldcol;

	/*to make sure beam and AedRCP agree: */
	moveto(&beam);
	beam.i_x = xaed;
	beam.i_y = yaed;

	fflush(ws->ws_ofile);

	if (trig == BRK_RUBBERB) {
		return('\0'); /* a GKS break */
	}
	else {
		ASS(*s, beam)
		ASS(sc->s_hit, beam)
		sc->s_code = trig;
		return(trig);
	}
}

/*
 * line_in_8() draws a line from (x0, y0) to (x1, y1) with either 
 * colour or 200 (draw) or colour 0 (erase) in 8th bitplane only (by
 * setting writemask to 0200). 
 * Coordinates are sent directly, and not by calling 
 * abscoord(). This is done to speed things up.
 */
line_in_8(ws, x0, y0, x1, y1, draw)
Wss	*ws;
int	x0, y0, x1, y1;
Bool	draw;
{
	if (graphmode == FALSE) alphamode();

	prefix(ESC);
	command(AedSEC);
	if (draw == TRUE) {
		value8(128);	/*make it a parameter */
		WsScrn->s_ccol = 128;
	}
	else {
		value8(0);
		WsScrn->s_ccol = 0;
	}

	command(AedMOV);
#if	(CODE == 1)
	fprintf(AedOUT,"%d %d ",x0, y0);
#endif
	command(AedDVA);
#if	(CODE == 1)
	fprintf(AedOUT,"%d %d ",x1, y1);
#endif
	/*
	beam.i_x = x1;
	beam.i_y = y1;
	*/
	graphmode = TRUE;
}

rect_in_8(ws, x0, y0, x1, y1, draw)
Wss	*ws;
int	x0, y0, x1, y1;
Bool	draw;
{
	Cindex	ci;

	if (draw == TRUE) ci = 200;/*to be changed in parameter*/
	else 	ci = 1;

	if (graphmode == FALSE) alphamode();
	prefix(ESC);
	command(AedSEC);
	value8((Int)ci);
	WsScrn->s_ccol = ci;

	command(AedMOV);
#if	(CODE == 1)
	fprintf(AedOUT,"%d %d ",x0, y0);
#endif
	command(AedDVA);
#if	(CODE == 1)
	fprintf(AedOUT,"%d %d ",x0, y1);
#endif
	command(AedDVA);
#if	(CODE == 1)
	fprintf(AedOUT,"%d %d ",x1, y1);
#endif
	command(AedDVA);
#if	(CODE == 1)
	fprintf(AedOUT,"%d %d ",x1, y0);
#endif
	command(AedDVA);
#if	(CODE == 1)
	fprintf(AedOUT,"%d %d ",x0, y0);
#endif
	graphmode = TRUE;
}

#endif
