/* @(#) aedpmk.h  version:1.6  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.aedpmk.h
 * SCCS id :	aedpmk.h 1.6
 * Last edited:	11/19/84 14:23:41
 */

/**********************POLYMARK*********************/
static
dr_dot(ws, s, msize )
Wss	*ws;
Msize	msize;
Ic	*s;
{	Screen *scr = WsScrn;

	if ((atbeam(s) == FALSE) || graphmode == TRUE) {
		moveto(s);
	}
	if (graphmode == TRUE) alphamode();
	prefix (ESC);
	command(AedWPX);
	value8((Int)scr->s_ccol);
}

static
dr_circle(ws, s, msize )
Wss	*ws;
Msize	msize;
Ic	*s;
{	register Int radius = (Int)(msize * CHARX * 0.4);

	if (radius == 0) dr_dot(ws, s, msize);
	else {
		if ((atbeam(s) == FALSE) || graphmode == TRUE) {
			moveto(s);
		}
		if (graphmode == TRUE) alphamode();
		prefix(ESC);
		command(AedDCL);
		valuev(radius);
	}
}

STATIC
mk_line(ws, scr, fromx, fromy, tox, toy)
Wss	*ws;
Screen	*scr;
Int	fromx, fromy, tox, toy;
{	Ic ic[2];
	ic[0].i_x = fromx; ic[0].i_y = fromy;
	ic[1].i_x = tox;   ic[1].i_y = toy;
	(*scr->s_line)(ws, 2, ic, SOLIDL, 1.0);
}

STATIC
dr_plus(ws, s, msize )
Wss	*ws;
Msize	msize;
Ic	*s;
{	register Int sz = (Int) (0.4 * msize * CHARX);
	Screen *scr = WsScrn;

	mk_line(ws, scr, s->i_x - sz, s->i_y, s->i_x + sz, s->i_y);
	mk_line(ws, scr, s->i_x, s->i_y - sz, s->i_x, s->i_y + sz);
}

STATIC
dr_asterisk(ws, s, msize )
Wss	*ws;
Msize	msize;
Ic	*s;
{	register Int sz = (Int)(0.4 * msize * CHARX);
	Screen *scr = WsScrn;
	register Int	up;

	up = (Int)(sz / sqrt(2.0));
	mk_line(ws, scr, s->i_x - sz, s->i_y, s->i_x + sz, s->i_y);
	mk_line(ws, scr, s->i_x, s->i_y - sz, s->i_x, s->i_y + sz);
	mk_line(ws, scr, s->i_x-up, s->i_y-up, s->i_x+up, s->i_y+up);
	mk_line(ws, scr, s->i_x+up, s->i_y-up, s->i_x-up, s->i_y+up);
}

static
dr_cross (ws, s, msize )
Wss	*ws;
Msize	msize;
Ic	*s;
{	register Int sz = (Int)(0.8 * msize * CHARX) / 2;
	Screen *scr = WsScrn;

	mk_line(ws, scr, s->i_x+sz, s->i_y+sz, s->i_x-sz, s->i_y-sz);
	mk_line(ws, scr, s->i_x+sz, s->i_y-sz, s->i_x-sz, s->i_y+sz);
}

static
Fun pmarkf[] = {
	dr_dot, 
	dr_plus,
	dr_asterisk, 
	dr_circle, 
	dr_cross
	};

STATIC
Bool drawmark(ws, n, s, ms, mt, eras)
Wss	*ws;
Size	n;
Ic	*s;
Msize	ms;
Mtype	mt;
Bool	eras;
{
	Set_Out(ws->ws_ofile);
	while (n--) (*pmarkf[mt-1])(ws, s++, ms);
}
