/*this picture shows the colour table*/
#include "cgksincl.h"

	Gks	*gkss;
	Wss	*wss_aed;
	Int 	n, ix, i, j, k, number;
	Real	r, pi2, white;
	Wc	*p1, *p2, *pt;
	Wc	p[10], q[2];
	AreaRep	fa;
	TextRep	tr;
	String	string;
	Drect	drect ;
	Nrect	nrect, nrect0= {0.0, 0.0, 1.0, 1.0};
	Wrect	wrect = {0.0, 0.0, 1.0, 1.0};
	Colour	col, bg_col = {0.7, 0.7, 0.1};

main()
{	gkss    = open_gks(NULL, NULL, NULL);
	wss_aed = open_ws(NULL, NULL, aed512);
	activate(wss_aed);

	setdrect(wss_aed, &drect, 20.0, 5.0, 490.0, 475.0);

	number = 15;
	r = 15.0;
	white  = 0.003;
	for (i = 1; i <= number; i++)
	for (j = 2; j <= number; j++) {
		nrect.n_ll.n_x = (i -1) / r + white;
		nrect.n_ll.n_y = (j - 1) / r + white;
		nrect.n_ur.n_x = (i ) / r - white;
		nrect.n_ur.n_y = (j ) / r - white;
		k = i + number * (j - 1);
		s_window  (gkss->gk_ntran[k], &wrect);
		s_viewport(gkss->gk_ntran[k], &nrect);
	}
	nrect.n_ll.n_x = white;
	nrect.n_ll.n_y = white;
	nrect.n_ur.n_x = 1 - white;
	nrect.n_ur.n_y = 1/ r - white;
	k = 1;
	s_window  (gkss->gk_ntran[k], &wrect);
	s_viewport(gkss->gk_ntran[k], &nrect);

	s_w_wind(wss_aed, &nrect0);
	s_w_view(wss_aed, &drect);
	update(wss_aed, TRUE);

	p1 = &p[0];
	pt = &q[0];

	p2 = p1; p2->w_x = 0.0; p2->w_y = 0.0;
	p2++;    p2->w_x = 1.0; p2->w_y = 0.0;
	p2++;    p2->w_x = 1.0; p2->w_y = 1.0;
	p2++;    p2->w_x = 0.0; p2->w_y = 1.0;

	col_rep(wss_aed, 0 , &bg_col);

	if (wss_aed->ws_wsd->wd_screen->s_colr) fa.fa_is = SOLID;
	else fa.fa_is = HOLLOW;

	for (i = 1; i <= number; i = i + 1) 
	for (j = 1; j <= number; j = j + 1) {
	     k = i + number * (j - 1);
	     col.c_red   = 1.0 - i/r;
	     col.c_blue  = 1.0 - j/r;
	     col.c_green =  i * j / (r * r);
	     col_rep(wss_aed, k, &col);
	     fa.fa_ci = k;
	     fa.fa_ix =  k ; fa_rep(wss_aed, &fa);
	}

	for (i = 1; i <= number; i++)
	for (j = 2; j <= number; j++) {
		k = i +  number * (j - 1);
		sel_cntran(gkss->gk_ntran[k]);
		ix = k;
		s_fa_i(ix);
		fillarea(4, p1);
	}
	k = 0;
	sel_cntran(gkss->gk_ntran[k]);

	s_ch_sp(0.005);
	pt->w_x = 0.03;
	pt->w_y = 0.024;
	s_ch_ht(0.03);
	tr.tx_ci = 160;
	tr.tx_chef = 1.0;
	tr.tx_ix = 2;
	tr.tx_fp.fp_fo = 8;
	tr.tx_fp.fp_pr = STR;
	tr.tx_ix =  2 ; tx_rep(wss_aed,&tr);
	s_tx_i(2);
	string = "Colour table via 210 fillarea's";
	text(string, pt);

	deactivate(wss_aed);
	close_ws(wss_aed);
	close_gks();
}

setdrect(ws, dr, llx, lly, urx, ury)
Wss	*ws;
Drect	*dr;
Real	llx, lly, urx, ury;
{
	Drect	maxsurf;

	ASS(maxsurf , ws->ws_wsd->wd_maxsurf)
	dr->d_ll.d_x = llx * maxsurf.d_ur.d_x / 511.0; 
	dr->d_ll.d_y = lly * maxsurf.d_ur.d_y / 482.0; 
	dr->d_ur.d_x = urx * maxsurf.d_ur.d_x / 511.0; 
	dr->d_ur.d_y = ury * maxsurf.d_ur.d_y / 482.0; 
}
