#include "cgksincl.h"

#define p2is(XX, YY)  p2->w_x = XX; p2->w_y = YY;

	Gks	*gkss;
	Wss	*wss_aed;
	Int 	n, i, k, number;
	Real	r, pi;
	Wc	*p1, *p2;
	AreaRep	fa;
	LineRep	lr;
	String	s1; 
	char	*str, *erf;

	Wrect	wrect3 = { 0.0, 0.0, 1.0, 0.5};
	Nrect	nrect3 = { 0.0, 0.0, 1.0, 0.5};
	Drect	drect3 = {40, 10, 500, 240};
	Drect	drecti1 = {10, 10, 35, 240},
		drecti2 = {40, 245, 500, 270},
		drecti3 = {10, 340, 200, 480},
		drecti4 = {210, 280, 500, 480},
		drecti5 = {40, 10, 500, 240},
		drecti6 = {10, 280, 200, 330};
	Drecord	dreci1, dreci2, dreci3, dreci4, dreci5, dreci6;
	Bool	goon=TRUE;
	Value	valx, valy;
	Choice	valch = 1, valchb = 1;
	String	fonts[10], *str_ptr;
	FoPr	fopr;
	String	choices[2];

	Locate	loc;

	Colour	col, bg_col = {0.5, 0.5, 0.5}, 
		yellow 	  ={1.0, 1.0, 0.0},
		white_col ={1.0, 1.0, 0.8};

	File	*fp_in, *fp_out;
	char	iofile[20];

show_wrect(wr)
Wrect	*wr;
{	p2 = p1;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ll.w_y; p2++;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ur.w_y; p2++;
	p2->w_x = wr->w_ur.w_x; p2->w_y = wr->w_ur.w_y; p2++;
	p2->w_x = wr->w_ur.w_x; p2->w_y = wr->w_ll.w_y; p2++;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ll.w_y;
}

setdrect(ws, dr, llx, lly, urx, ury)
Wss	*ws;
Drect	*dr;
Real	llx, lly, urx, ury;
{
	Drect	maxsurf;

	ASS(maxsurf , ws->ws_wsd->wd_maxsurf)
	dr->d_ll.d_x = llx * maxsurf.d_ur.d_x / 511.0; 
	dr->d_ll.d_y = lly * maxsurf.d_ur.d_y / 482.0; 
	dr->d_ur.d_x = urx * maxsurf.d_ur.d_x / 511.0; 
	dr->d_ur.d_y = ury * maxsurf.d_ur.d_y / 482.0; 
}

main(argc, argv)
int	argc;
char	*argv[];
{
	if (argc < 3) {
		fp_in = fp_out = NULL;
	}
	else  {
		sprintf(iofile, "/dev/tty%s",argv[1]);
		if ((fp_in = fopen(iofile, "r")) == NULL) {
			fprintf(stderr,"can't open %s for reading\n",
				iofile);
			return;
		}
		sprintf(iofile, "/dev/tty%s",argv[2]);
		fp_out = fopen(iofile, "w");
		setbuf(fp_out, (char *) NULL);
	}

	gkss    = open_gks(NULL, NULL, NULL,"mess14");
	wss_aed = open_ws(fp_in, fp_out, aed512);
	activate(wss_aed);

	setdrect(wss_aed, &drect3, 40.0, 10.0, 500.0, 240.0);
	setdrect(wss_aed, &drecti1, 10.0, 10.0, 35.0, 240.0),
	setdrect(wss_aed, &drecti2, 40.0, 245.0, 500.0, 270.0),
	setdrect(wss_aed, &drecti3, 10.0, 340.0, 200.0, 480.0),
	setdrect(wss_aed, &drecti4, 210.0, 280.0, 500.0, 480.0),
	setdrect(wss_aed, &drecti5, 40.0, 10.0, 500.0, 240.0),
	setdrect(wss_aed, &drecti6, 10.0, 280.0, 200.0, 330.0);

	col_rep(wss_aed,   0, &bg_col);
	col_rep(wss_aed, 255, &white_col);
	col_rep(wss_aed, 254, &yellow);

	lr.lr_lt = SOLIDL;
	fa.fa_is = SOLID;

	number = 15; r = 15.0;


	pi = 3.141;
	for (i=1; i<250; i = i +1) {
		col.c_red   = (sin(2 * i * pi / 255.0) + 1.0) / 2.0;
		col.c_green = (sin(2 * i * pi / 255.0 + 2* pi/ 3) + 1.0) / 2.0;

		col.c_blue = (sin(2 * i * pi / 255.0 + 4 * pi / 3) + 1.0) / 2.0;

	     col_rep(wss_aed, i, &col);

	     lr.lr_ci = i; 
	     lr.lr_ix =  i ; pl_rep(wss_aed, &lr);
	     fa.fa_ci = i;
	     fa.fa_ix =  i ; fa_rep(wss_aed, &fa);
	}


	s_w_wind(wss_aed, &nrect3);
	s_w_view(wss_aed, &drect3);
	update(wss_aed, TRUE);

	n = 200;
	CALLOC(p1, Wc, n, MAIN)

	
	k = 3;
	s_window  (gkss->gk_ntran[k], &wrect3);
	s_viewport(gkss->gk_ntran[k], &nrect3);
	sel_cntran(gkss->gk_ntran[k]);
	s_vip(gkss->gk_ntran[k], gkss->gk_ntran[0], TRUE);

	while(goon) {
	show_wrect(&wrect3);
	s_fa_i(34);
	fillarea(4, p1);


	/*****input ********/

	dreci5.loc_rec.loc_col = 200;
	loc.loc_pt.w_x = loc.loc_pt.w_y = 0.0;
	loc.loc_nt = gkss->gk_ntran[0];
	init_loc(wss_aed, 1, &loc, 1, &drect3, &dreci5);
	req_loc(wss_aed, 1, &loc);


	valy = 0.5;
	dreci1.val_rec.val_max = 1.0;
	dreci1.val_rec.val_min = 0.0;
	dreci1.val_rec.val_col = 200;
	init_val(wss_aed, 1, &valy, 1, &drecti1, &dreci1);
	req_val(wss_aed, 1, &valy);

	s_ch_ht(valy * 0.5);
	valx= 0.5;

	dreci2.val_rec.val_max = 1.0;
	dreci2.val_rec.val_min = 0.0;
	dreci2.val_rec.val_col = 200;
	init_val(wss_aed, 1, &valx, 1, &drecti2, &dreci2);
	req_val(wss_aed, 1, &valx);
	
	if (valy != 0.0) s_ch_ef(0.5 * valx / valy);
	else s_ch_ef(1.0);

	str_ptr = fonts;  

	*str_ptr++ = "clarendon.18";
	*str_ptr++ = "bodoni.i.10";
	*str_ptr++ = "times.b.10";
	*str_ptr++ = "meteor.r.12";
	*str_ptr++ = "meteor.i.10";
	*str_ptr++ = "stare.i.16";
	*str_ptr++ = "stare.b.16";
	*str_ptr++ = "playbill.10";
	*str_ptr++ = "delegate.b.12";
	*str_ptr++ = "fix.14";
	dreci4.cho_rec.cho_nr = 10;
	dreci4.cho_rec.cho_col = 200;
	dreci4.cho_rec.cho_str = fonts;
	init_cho(wss_aed, 1, &valch, 3, &drecti4, &dreci4);
	req_cho(wss_aed, 1, &valch);
	fopr.fp_fo= (Tfont)(valch +1);
	fopr.fp_pr= STR;
	s_tx_fp(fopr);
	s_tx_ci(160);
	s_asflags(01300);
	
	str = "init-str";
	dreci3.str_rec.str_size = 24;
	dreci3.str_rec.str_posn = 1;
	dreci3.str_rec.str_col = 200;
	init_str(wss_aed, 1, str, 1, &drecti3, &dreci3);
	CALLOC(s1, char, 32+1, MAIN)
	req_str(wss_aed, 1, s1);

	text(s1, &loc.loc_pt);

	str_ptr = choices;  
	*str_ptr++ = "stop";
	*str_ptr   = "again";
	dreci6.cho_rec.cho_nr = 2;
	dreci6.cho_rec.cho_str = choices;
	dreci6.cho_rec.cho_col = 200;
	init_cho(wss_aed, 1, &valchb, 3, &drecti6, &dreci6);
	req_cho(wss_aed, 1, &valchb);
	goon = (Bool)(valchb - 1);
	if (goon) clear(wss_aed, TRUE);
	}


	deactivate(wss_aed);
	close_ws(wss_aed);
	close_gks();
}
