#define GKS1
#define GKS2
#define GKS3
#define GKS5
#define GKS4
#define GKS6
#define GKS8
#define GKS9
#define GKS7
#include "cgksincl.h"

Gks	*gkss;
extern	Gksd	*gksd;
Wss	*wss_mo1, *wss_mo2, *wss_mi, *wss_ver, *wss_wis;
File	*metaout1, *metaout2 , *metain;
Wc	p1[5];

Nrect nr;
Wrect wr;


#define MAXREC 1024
char *datrec ;

Int type, lrec;
Int i;

main()
{
	
	Seg *newseg();
	Seg *s1, *s2, *s3, *s4;
	Segname sn1 = 1, sn2 = 2, sn3 = 3, sn4 = 4;

	Tmat tm;
	Charht ht = 0.1;


	FoPr fopr;
	if ((metaout1 = fopen("pic41.mf", "w")) == NULL) {
		fprintf(stderr,"not allowed to open a file here\n");
		exit();
	}

	fopr.fp_fo = 2;
	fopr.fp_pr = STR;
	tm[0][0] = .707;
	tm[0][1] = .717;
	tm[0][2] = 0.01;
	tm[1][0] = .727;
	tm[1][1] = -.707;
	tm[1][2] = -0.01;

	setbuf(metaout1,NULL);
	gkss   = open_gks(NULL, NULL, NULL, "pic41.er");
	wss_mo1 = open_ws(NULL, metaout1, mo);
	
	wss_ver = open_ws(NULL, NULL, versatec);
	activate(wss_ver);
	activate(wss_mo1);

	s_tx_fp(fopr);
	s_ch_ht(ht);
	s1 = newseg(sn1);

	for (i=0; i<5; i++)
	{
		p1[i].w_x = i/4.0;
		p1[i].w_y = i*i/16.0;
	}

/*
*	normalization transformations
*/
	nr.n_ur.n_x = 0.9;
	nr.n_ur.n_y = 0.9;

	nr.n_ll.n_x = 0.5;
	nr.n_ll.n_y = 0.5;

	s_viewport(gkss->gk_ntran[1], &nr);

	nr.n_ur.n_x = 0.9;
	nr.n_ur.n_y = 0.5;

	nr.n_ll.n_x = 0.5;
	nr.n_ll.n_y = 0.1;

	s_viewport(gkss->gk_ntran[2], &nr);

	nr.n_ur.n_x = 0.5;
	nr.n_ur.n_y = 0.9;

	nr.n_ll.n_x = 0.1;
	nr.n_ll.n_y = 0.5;

	s_viewport(gkss->gk_ntran[3], &nr);

	nr.n_ur.n_x = 0.5;
	nr.n_ur.n_y = 0.5;

	nr.n_ll.n_x = 0.1;
	nr.n_ll.n_y = 0.1;

	s_viewport(gkss->gk_ntran[4], &nr);

	s_asflags(017777);

	s_pl_i(2);
	s_lt(2);
	s_lw(0.5);
	s_pl_ci(3);


	sel_cntran(gkss->gk_ntran[1]);

	text("polyline",&p1[2]);
	polyline(5, p1);

	closeg();
	s2 = newseg(sn2);

	s_pm_i(2);
	s_mt(2);
	s_msz(2.5);
	s_pm_ci(1);

	sel_cntran(gkss->gk_ntran[2]);

	text("polymark",&p1[2]);
	polymark(5, p1);
	closeg();

	zapseg(s1);
	renameseg(sn2,sn1);
	s4 = newseg(sn4);

	s_fa_i(1);
	s_fa_is(HOLLOW);
	s_fa_si(1);
	s_fa_ci(1);
	
	sel_cntran(gkss->gk_ntran[3]);

	text("fillarea",&p1[2]);
	fillarea(5,p1);


	s_ch_ef(1.2);
	s_ch_sp(.1);
	s_tx_ci(2);
	s_tx_i(3);

	sel_cntran(gkss->gk_ntran[4]);

	text("text",&p1[2]);


	closeg();


	transeg(s4,tm);
	s_segvis(s4,FALSE);
	s_detect(s4,FALSE);
	s_hilite(s4,TRUE);
	s_segpri(s4,0.5);


	zapseg(s2);
	zapseg(s4);

	deactivate(wss_mo1);
	close_ws(wss_mo1);
	fclose(metaout1);

	deactivate(wss_ver);
	close_ws(wss_ver);

	close_gks();
}
