#include "cgksincl.h"

#define BARS 14

typedef(*FPTR)();

extern GksState	gkstate;
extern	Gks	*gkss;
extern	Gksi	*gksis;
	Bool	coord_in_rect();
	static Int 	i=0, j=0, k=0, l=0;
	extern	Real	xrat, yrat, ychange;
	extern	Wc	*p1, *p2 ;
	extern	Wc	pc1, pc2, pc3, pc4;
	extern	TextRep tr;
	extern	String	str, stringtx, errorstr;

typedef struct{
	String	t_str; 
	Wc 	t_wc;
	} tx_wc;
	extern	tx_wc	tx_buf[];
	extern	Int	lasttx;

	extern	Wrect	wrect2 ;
	extern	Wrect	wrect3 ;
	extern	Wrect	wrect4 ;

	extern	Nrect	nrect2 ;
	
	extern	Wrect	column[BARS], *colmptr,  column0;
	extern Wss	*wss_aed;
	extern char	strtx[64];
	extern 	Colour bg_col, green, blue, col;
	extern	Int	styles[BARS], cur_style;

extern LineRep lr;
extern MarkRep mr;
extern TextRep tr;
extern AreaRep fa;
	extern	Real	a_col, b_col;
	extern	Wc	firstt, ending;

	extern	Choice	val1, lastchoice;
	extern	Locate	loc2;

	extern	Bool	heightsknown;

	extern	Int	barnr;

f_solid();
f_hor();
f_ver();
f_diagon();
f_dot();

FPTR stylefun[]={f_solid, f_hor, f_ver, f_diagon, f_dot};

comment(str1,str2, str3,str4)
String str1, str2, str3, str4;
{
	s_tx_i(1);
	pc1.w_x = pc2.w_x = pc3.w_x = pc4.w_x = 0.18;
	pc1.w_y = 0.11;
	pc2.w_y = 0.08;
	pc3.w_y = 0.05;
	pc4.w_y = 0.02;
	if(strlen(str1)) {
		fadearea(&wrect4, 0);
		text(str1, &pc1);
	}
	if (strlen(str2))  text(str2, &pc2);
	if (strlen(str3))  text(str3, &pc3);
	if (strlen(str4))  text(str4, &pc4);
}

Bool coord_in_rect(wrect, wc)
Wrect	*wrect;
Wc	*wc;
{	Real yup, ydown;
	if(wrect->w_ll.w_y < wrect->w_ur.w_y){
		yup   = wrect->w_ur.w_y;
		ydown = wrect->w_ll.w_y;
	}
	else {
		yup   = wrect->w_ll.w_y;
		ydown = wrect->w_ur.w_y;
	}
	return  (Bool) ((wc->w_x >= wrect->w_ll.w_x) &&
		    (wc->w_y >= ydown) &&
		    (wc->w_x <= wrect->w_ur.w_x) &&
		    (wc->w_y <= yup)
		   ); 
}

showwrect(wr, index)
Wrect	*wr;
Bindex	index;
{	p2 = p1;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ll.w_y; p2++;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ur.w_y; p2++;
	p2->w_x = wr->w_ur.w_x; p2->w_y = wr->w_ur.w_y; p2++;
	p2->w_x = wr->w_ur.w_x; p2->w_y = wr->w_ll.w_y; p2++;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ll.w_y;
	s_fa_i(index);
	fillarea(4, p1);
}

axes(origin)
Wc	*origin;
{
	s_pm_i(2);
	polymark(1, origin);
	p1[0].w_x = origin->w_x;
	p1[0].w_y = origin->w_y;
	p1[1].w_y = 0.98 * wrect2.w_ur.w_y;
	p1[1].w_x = p1[0].w_x;
	polyline(2, p1);
		
	p1[1].w_x = 0.99 * wrect2.w_ur.w_x;
	p1[1].w_y = p1[0].w_y;
	polyline(2, p1);
}

stripes(visible)
Bool visible;
{	Wc stpt[2];
	Int count;

	bar_yupdate();

	ASS(firstt , loc2.loc_pt)
	ending.w_y = firstt.w_y;
	ending.w_x = 0.97 * wrect2.w_ur.w_x;
	stpt[0].w_y = firstt.w_y - 0.003;
	stpt[1].w_y = firstt.w_y + 0.006;
	a_col = (ending.w_x - firstt.w_x) / (barnr * 8.0);
	b_col = 7.0 * a_col;
	if (visible) s_pl_i(1);
	else	s_pl_i(0);
	stpt[0].w_x = firstt.w_x;
	stpt[1].w_x = firstt.w_x;
	colmptr = &column[0];
	for (count = 0; count < barnr; count++) {
		stpt[0].w_x += a_col;
	 	stpt[1].w_x += a_col; 
		polyline(2, stpt);
		if (visible) colmptr->w_ll.w_x = stpt[0].w_x;
		stpt[0].w_x += b_col;
	 	stpt[1].w_x += b_col; 
		polyline(2, stpt);
		if (visible) colmptr->w_ur.w_x = stpt[0].w_x;
		colmptr++;
	}
	if (visible == FALSE || val1 == 6) {
		ASS(stpt[0] , firstt)
		ASS(stpt[1] , ending)
		s_pl_i(1);
		polyline(2, stpt);
	}
}

bar_yupdate()
{
	Int i;
	colmptr = &column[0];
	for (i = 0; i < BARS; i++) {
		if(!heightsknown){
			colmptr->w_ll.w_y = loc2.loc_pt.w_y;
			colmptr->w_ur.w_y = loc2.loc_pt.w_y;
		}
		else if (val1 == 1) {
			colmptr->w_ll.w_y += ychange; 
			colmptr->w_ur.w_y += ychange;
		}
		else if (val1 == 6) {
			if (i < barnr) fadearea(colmptr, 0);
			colmptr->w_ur.w_y = colmptr->w_ll.w_y;
			styles[i] = 0;
		}
		colmptr++;
	}
}
fadearea(wrect, is)
Wrect	*wrect;
Int	is;
{	
	showwrect(wrect, is);
}

f_solid(wrect)
Wrect *wrect;
{
	showwrect(wrect, 2);
}

wr_nr(wrect, wr, nr)
Wrect	*wrect, *wr;
Nrect	*nr;
{
	wr->w_ll.w_x = wrect->w_ll.w_x;
	wr->w_ur.w_x = wrect->w_ur.w_x;
	if (wrect->w_ur.w_y >= wrect->w_ll.w_y) {
		wr->w_ll.w_y = wrect->w_ll.w_y;
		wr->w_ur.w_y = wrect->w_ur.w_y;
	}
	else {
		wr->w_ur.w_y = wrect->w_ll.w_y;
		wr->w_ll.w_y = wrect->w_ur.w_y;
	}
	nr->n_ll.n_x = wr->w_ll.w_x;
	nr->n_ll.n_y = wr->w_ll.w_y;
	nr->n_ur.n_x = wr->w_ur.w_x;
	nr->n_ur.n_y = wr->w_ur.w_y;
}

f_hor(wrect)
Wrect *wrect;
{
	Nrect nrct;
	Wrect wrct;
	Wc *pt= &p1[0];
	Ntran *ctran = gkss->gk_curnt;
	register Int t;
	for (t = 0; t < 75; t++) {
		pt[4*t].w_x = 0.0;
		pt[4*t].w_y = 4 * t / 300.0;
		pt[4*t + 1].w_x = 1.0;
		pt[4*t + 1].w_y = 4 * t / 300.0;
		pt[4*t + 2].w_x = 1.0;
		pt[4*t + 2].w_y = (4 * t + 2.0) / 300.0;
		pt[4*t + 3].w_x = 0.0;
		pt[4*t + 3].w_y = (4 * t + 2.0) / 300.0;
	}
	wr_nr(wrect, &wrct, &nrct);
	s_window  (gkss->gk_ntran[12], &wrct);
	s_viewport(gkss->gk_ntran[12], &nrct);
	sel_cntran(gkss->gk_ntran[12]);
	s_lt(SOLID);
	s_asflags(01);
	polyline(300, pt);
	s_asflags(0);
	s_lt(SOLIDL);
	sel_cntran(ctran);
}

f_ver(wrect)
Wrect *wrect;
{
	Nrect nrct;
	Wrect wrct;
	Ntran *ctran = gkss->gk_curnt;
	register Int t;
	Wc *pt= p1;
	for (t = 0; t < 75; t++) {
		pt[4*t].w_y = 0.0;
		pt[4*t].w_x = 4 * t / 300.0;
		pt[4*t + 1].w_y = 1.0;
		pt[4*t + 1].w_x = 4 * t / 300.0;
		pt[4*t + 2].w_y = 1.0;
		pt[4*t + 2].w_x = (4 * t + 2.0) / 300.0;
		pt[4*t + 3].w_y = 0.0;
		pt[4*t + 3].w_x = (4 * t + 2.0) / 300.0;
	}
	wr_nr(wrect, &wrct, &nrct);
	s_window  (gkss->gk_ntran[12], &wrct);
	s_viewport(gkss->gk_ntran[12], &nrct);
	sel_cntran(gkss->gk_ntran[12]);
	polyline(300, pt);
	sel_cntran(ctran);
}

f_diagon(wrect)
Wrect *wrect;
{
	Nrect nrct;
	Wrect wrct;
	register Int t;
	Wc *pt= p1;
	Ntran *ctran = gkss->gk_curnt;
	for (t = 0; t < 150; t++) {
		pt[4*t].w_x = 0.0;
		pt[4*t].w_y = 4 * t / 300.0-1.0;
		pt[4*t + 1].w_x = 1.0;
		pt[4*t + 1].w_y = 4 * t / 300.0 ;
		pt[4*t + 2].w_x = 1.0;
		pt[4*t + 2].w_y = (4 * t + 2.0) / 300.0 ;
		pt[4*t + 3].w_x = 0.0;
		pt[4*t + 3].w_y = (4 * t + 2.0) / 300.0 - 1.0;
	}
	wr_nr(wrect, &wrct, &nrct);
	s_window  (gkss->gk_ntran[12], &wrct);
	s_viewport(gkss->gk_ntran[12], &nrct);
	sel_cntran(gkss->gk_ntran[12]);
	polyline(600, pt);
	sel_cntran(ctran);
}

f_dot(wrect)
Wrect *wrect;
{
	Nrect nrct;
	Wrect wrct;
	register Int t;
	Wc *pt= p1;
	Ntran *ctran = gkss->gk_curnt;
	for (t = 0; t < 75; t++) {
		pt[4*t].w_y = 0.0;
		pt[4*t].w_x = 4 * t / 300.0;
		pt[4*t + 1].w_y = 1.0;
		pt[4*t + 1].w_x = 4 * t / 300.0;
		pt[4*t + 2].w_y = 1.0;
		pt[4*t + 2].w_x = (4 * t + 2.0) / 300.0;
		pt[4*t + 3].w_y = 0.0;
		pt[4*t + 3].w_x = (4 * t + 2.0) / 300.0;
	}
	wr_nr(wrect, &wrct, &nrct);
	s_window  (gkss->gk_ntran[12], &wrct);
	s_viewport(gkss->gk_ntran[12], &nrct);
	sel_cntran(gkss->gk_ntran[12]);
	s_lt(SOLID);
	s_asflags(01);
	polyline(300, pt);
	s_asflags(0);
	s_lt(SOLID);
	sel_cntran(ctran);
}


interior(bar_nr, style)
Int	bar_nr;
Int	style;
{
	if (style >0 && style < 6) {
		if (styles[bar_nr]) {
			fadearea(&column[bar_nr]);
			showwrect(&column[bar_nr], 1);
		}
		(*stylefun[style - 1])(&column[bar_nr]);
	}
}

showalltext(ix)
Bindex ix;
{
	s_tx_i(ix);
	if (lasttx)
	for (j = 0; j < lasttx; j++){
		 text(tx_buf[j].t_str, &(tx_buf[j].t_wc));
	}
}
inst_bundles()
{
	lr.lr_lt = SOLIDL;
	lr.lr_ci = 0;
	lr.lr_ix = 0;
	pl_rep(wss_aed, &lr);

	tr.tx_fp.fp_fo = 1;
	tr.tx_fp.fp_pr = STR;
	tr.tx_ci = 0;
	tr.tx_chef = 1.0;
	tr.tx_ix =  0 ; tx_rep(wss_aed, &tr);
	tr.tx_ci = 1;
	tr.tx_ix =  1 ; tx_rep(wss_aed, &tr);

	mr.mr_mt = MTPLUS;
	mr.mr_ci = 0;
	mr.mr_ix =  0 ; pm_rep(wss_aed, &mr);

	stringtx = strtx;

	col_rep(wss_aed,   0, &bg_col);
	col_rep(wss_aed,   255, &blue);
	col_rep(wss_aed, 1, &green);

	for (i=1; i<250; i = i +1) {
		ASS(col , green)
		col_rep(wss_aed, i, &col);

		lr.lr_ci = i; 
		lr.lr_ix = i; 
		pl_rep(wss_aed, &lr);
	}
	fa.fa_ci = 0;
	fa.fa_is = SOLID;
	fa.fa_ix =  0 ; fa_rep(wss_aed, &fa);
	fa.fa_is = HOLLOW;
	fa.fa_ix =  3 ; fa_rep(wss_aed, &fa);
	fa.fa_ci = 1;
	fa.fa_is = HOLLOW;
	fa.fa_ix =  1 ; fa_rep(wss_aed, &fa);
	fa.fa_is = SOLID;
	fa.fa_ix =  2 ; fa_rep(wss_aed, &fa);
}
