#define WITHOUTBOX
/*#define PET_RUBBERBAND /* */

#include "cgksincl.h"

#include "inquire.h"

#define flagsglobal() s_asflags(017777)
#define	flagslocal() s_asflags(0)

extern	Gks	*gkss;
extern	Gksi	*gksis;
	Bool	coord_in_rect();
	extern 	Wss	*wss_aed;
	Int 	i, j, k, l;
	extern	Wc	*p1, *p2 ;
	Wc	*p3;
	extern	Real	ch_y;
	extern 	Wc	pc[5];
	extern	Wrect	wrect[], wrect4, wr_upv, wrectot;
	extern	Nrect	nrect[];
	extern 	Real	curmsz, curht, curwd;
	extern 	Real	dev[13];
	extern	String	polstr[6];
	extern	String	textat[2];
	extern	String	fontstr[4];
	extern	String	fillstr[2];
	extern	String	primstr[9];
	extern	String	segmtx[9];
	extern	String	c[];

	extern	FoPr	fp;
	extern	Drecord	drectx;
	extern 	Drect	drecttx;
	extern	Colour bg_col, green, white, blue, col;
	extern	String stringtx;
	extern	char strtx[];
	extern	Int lastattshown;
	extern	File *aed_in, *aed_out;

	extern	Bool	ul;
	/*indicates if there is still a choice underlined */
	extern	Wrect	*wrprev; /*previous underlined box */

s_if_of(argc, argv)
int	argc;
char	*argv[];
{
	if (argc >= 2) {
		if (strcmp(argv[1], "stdin") == 0)
			aed_in = stdin;
		else { 	aed_in = fopen(argv[1],"r");
			if (aed_in == NULL) {
				fprintf(stderr,"can't open input file\n");
				return;
			}
			setbuf(aed_in, (char *)NULL);
		}
	}
	else	aed_in = stdin;

	if (argc >= 3) {
		if (strcmp(argv[2], "stdout") == 0)
			aed_out = stdout;
		else {	aed_out = fopen(argv[2], "w");
			setbuf(aed_out, (char *)NULL);
		}
	}
	else 	aed_out = stdout;
}

inst_transf(nr)
Int	nr;
{	/*transform 1 to 6 are for filltype selection */
	for (k = 1; k <= nr; k++) {
		s_window  (gkss->gk_ntran[k], &wrect[k-1]);
		s_viewport(gkss->gk_ntran[k], &nrect[k-1]);
		s_vip(gkss->gk_ntran[k], gkss->gk_ntran[0], TRUE);
	}
	s_vip(gkss->gk_ntran[17], gkss->gk_ntran[8], TRUE);
}

showdot(p)
Wc	*p;
{
	flagslocal();
	s_pm_i(1);
	polymark(1, p);
	flagsglobal();
}

fadedots(n, p1)
Size 	n;
Wc	*p1;
{
	s_pm_i(0);
	flagslocal();
	polymark(n, p1);

	flagsglobal();
}


comment(str1,str2, str3,str4)
String str1, str2, str3, str4;
{
	s_tx_i(1);
	if(strlen(str1)) {
		fadearea(&wrect4, 0);
		flagslocal();
		text(str1, &pc[1]);
	}
	flagslocal();
	if (strlen(str2))  text(str2, &pc[2]);
	if (strlen(str3))  text(str3, &pc[3]);
	if (strlen(str4))  text(str4, &pc[4]);
	flagsglobal();
}

Bool coord_in_rect(wrect, wc)
Wrect	*wrect;
Wc	*wc;
{	
	return  (Bool) ((wc->w_x >= wrect->w_ll.w_x) &&
		    (wc->w_y >= wrect->w_ll.w_y) &&
		    (wc->w_x <= wrect->w_ur.w_x) &&
		    (wc->w_y <= wrect->w_ur.w_y)
		   ); 
}

showwrect(wr, index)
Wrect	*wr;
Bindex	index;
/*index=0: fade rect
 *      1: fade boundary of rect
 *      2: hollow rect colour 1
 *      3: solid rect colour 1
 */
{
	Wc	p[4], *ptr;
	ptr = &p[0];
	*ptr = wr->w_ll; ptr++;
	ptr->w_x = wr->w_ll.w_x; ptr->w_y = wr->w_ur.w_y; ptr++;
	*ptr = wr->w_ur; ptr++;
	ptr->w_x = wr->w_ur.w_x; ptr->w_y = wr->w_ll.w_y;
	s_fa_i(index);
	flagslocal();
	fillarea(4, &p[0]);
 	flagsglobal();
}

under_line(wr, index)
Wrect	*wr;
Bindex	index;
/*index=
 *      0: fade floor line of rect
 *      1: draw floor line of rect
 */
{
	Wc	p[2], *ptr;

	ptr = &p[0];
	ASS(*ptr , wr->w_ll)
	ptr++;
	ptr->w_x = wr->w_ur.w_x;
	ptr->w_y = wr->w_ll.w_y;
	s_pl_i(index);
	flagslocal();
	polyline(2, &p[0]);
 	flagsglobal();

	wrprev = wr;
}

fadearea(wrect, is)
Wrect	*wrect;
Int	is;
{	
	showwrect(wrect, is);
}


showcolours()
{
	Wc	ll, ur;
	register Int t;
	Wc	pt[4] , *wcptr;
	Real devi; 
	Real step;
	Int max;

	step = 10;
	ll = wrect[7].w_ll;
	ur = wrect[7].w_ur;
/*
#ifndef PET_RUBBERBAND
	max = 246;
	step = 10;
#else
*/
	max = 123;
	step = 5;
/*
#endif
*/
	devi = step * (wrect[7].w_ur.w_y - wrect[7].w_ll.w_y ) /
							(Real)max;
	flagslocal();
	wcptr = &(pt[0]);
	wcptr->w_x	= ll.w_x;
	(wcptr++)->w_y	= ur.w_y - devi;
	wcptr->w_x	= ll.w_x;
	(wcptr++)->w_y	= ur.w_y;
	*wcptr++	= ur;
	wcptr->w_x	= ur.w_x;
	wcptr->w_y	= ur.w_y - devi;
	for (t = 4; t < 4+max;  t += step) {
		s_fa_i(7+max - t);
		wcptr = &pt[0];
		fillarea(4, wcptr);
		for (j = 0; j < 4; j++) (wcptr++)->w_y -= devi;
	}
	showwrect(&wrect[16], 0);
	flagsglobal();
}

setfirstrect(wcptr, rectnr, devi)
Wc	*wcptr;
Int	rectnr;
Real	devi;
{
	wcptr->w_x	= wrect[rectnr].w_ll.w_x;
	(wcptr++)->w_y	= wrect[rectnr].w_ur.w_y - devi;
	wcptr->w_x	= wrect[rectnr].w_ll.w_x;
	(wcptr++)->w_y	= wrect[rectnr].w_ur.w_y;
	*wcptr++	= wrect[rectnr].w_ur;
	wcptr->w_x	= wrect[rectnr].w_ur.w_x;
	wcptr->w_y	= wrect[rectnr].w_ur.w_y - devi;
}

showlinetypes()
{
	Wc	pt[4], pp, *wcptr;
	Real devi ;

	devi = (wrect[8].w_ur.w_y - wrect[8].w_ll.w_y ) / 6.0;
	flagslocal();
	wcptr = &(pt[0]);
	setfirstrect(wcptr, 8, devi);
	wcptr = &(pt[0]);
	pp.w_x = pt[0].w_x + 0.03;
	pp.w_y = (pt[0].w_y + pt[2].w_y) / 2.0;
	s_fa_i(1);
	for (i = 0; i < 6; i++) {
		wcptr = &pt[0];
		fillarea(4, wcptr);
		text(polstr[i], &pp);
		pp.w_y -= devi;
		for (j = 0; j < 4; j++) (wcptr++)->w_y -= devi;
	}
	flagsglobal();
}

showmarktypes()
{
	Wc	pt[4], pp, *wcptr;
	Real devi ;

	devi = (wrect[10].w_ur.w_y - wrect[10].w_ll.w_y ) / 5.0;
	flagslocal();
	wcptr = &(pt[0]);
	setfirstrect(wcptr, 10, devi);
	wcptr = &(pt[0]);
	pp.w_x = pt[0].w_x + 0.06;
	pp.w_y = (pt[0].w_y + pt[2].w_y) / 2.0;
	s_fa_i(1);
	for (i = 0; i < 5; i++) {
		wcptr = &pt[0];
		fillarea(4, wcptr);
		s_pm_i(i + 1);
		polymark(1, &pp);
		pp.w_y -= devi;
		for (j = 0; j < 4; j++) (wcptr++)->w_y -= devi;
	}
	flagsglobal();
}

showfonttypes()
{
	Wc	pt[4], pp, *wcptr;
	Real devi ;

	devi = (wrect[12].w_ur.w_y - wrect[12].w_ll.w_y ) / 4.0;
	flagslocal();
	wcptr = &(pt[0]);
	setfirstrect(wcptr, 12, devi);
	wcptr = &(pt[0]);
	pp.w_x = pt[0].w_x + 0.01;
	pp.w_y = (pt[0].w_y + pt[2].w_y) / 2.0;
	s_fa_i(1);
	for (i = 0; i < 4; i++) {
		wcptr = &pt[0];
		fillarea(4, wcptr);
		text(fontstr[i], &pp);
		pp.w_y -= devi;
		for (j = 0; j < 4; j++) (wcptr++)->w_y -= devi;
	}
	flagsglobal();
}

showfilltypes()
{
	Wc	pt[4], pp, *wcptr;
	Wrect	*wr;
	Real devi ;

	wr = &wrect[9];
	devi = (wr->w_ur.w_y - wr->w_ll.w_y ) / 2.0;
	flagslocal();
	wcptr = &(pt[0]);
	wcptr->w_x	= wr->w_ll.w_x;
	(wcptr++)->w_y	= wr->w_ur.w_y - devi;
	wcptr->w_x	= wr->w_ll.w_x;
	(wcptr++)->w_y	= wr->w_ur.w_y;
	*wcptr++	= wr->w_ur;
	wcptr->w_x	= wr->w_ur.w_x;
	wcptr->w_y	= wr->w_ur.w_y - devi;
	wcptr = &(pt[0]);
	pp.w_x = pt[0].w_x + 0.03;
	pp.w_y = (pt[0].w_y + pt[2].w_y) / 2.0;
	s_fa_i(1);
	for (i = 0; i < 2; i++) {
		wcptr = &pt[0];
		fillarea(4, wcptr);
		text(fillstr[i], &pp);
		pp.w_y -= devi;
		for (j = 0; j < 4; j++) (wcptr++)->w_y -= devi;
	}
	flagsglobal();
}

showsize(wrect, frac)
Wrect	*wrect;
Real	frac;
{
	Wc	p[2];
	s_fa_i(1);
	showwrect(wrect, 0);
	showwrect(wrect, 1);
	flagslocal();
	if ((wrect->w_ur.w_y - wrect->w_ll.w_y) <
	    (wrect->w_ur.w_x - wrect->w_ll.w_x)) {
		p[0].w_x = wrect->w_ll.w_x;
		p[1].w_y = p[0].w_y =
			(wrect->w_ur.w_y + wrect->w_ll.w_y) / 2.0;
		p[1].w_x = frac * wrect->w_ur.w_x +
			(1.0 - frac) * wrect->w_ll.w_x;
	}
	else {
		p[0].w_y = wrect->w_ll.w_y;
		p[1].w_x = p[0].w_x =
			(wrect->w_ur.w_x + wrect->w_ll.w_x) / 2.0;
		p[1].w_y = frac * wrect->w_ur.w_y +
			(1.0 - frac) * wrect->w_ll.w_y;
	}
	if (inq_gks(gkss, gk_line) != 1) s_pl_i(1);
	polyline(2, &p[0]);
	flagsglobal();
}

transpose(p, prev)
Wc	*p, *prev;
{	
	if ((p->w_x != prev->w_x) &&(fabs(p->w_y - prev->w_y)
		/ fabs(p->w_x - prev->w_x)) < 0.1) { 
		p->w_y = prev->w_y;
	}
	else if ((p->w_y != prev->w_y) &&(fabs(p->w_x - prev->w_x)
		/ fabs(p->w_y - prev->w_y)) < 0.1) { 
		p->w_x = prev->w_x;
	}
}

lineatt()
{
	Wc p1[2];
	Wrect wr;
	p1->w_x = 0.01;
	p1->w_y = 0.22 - 2.0 * ch_y;
	(p1 + 1)->w_x =0.30;
	(p1 + 1)->w_y =0.22 - 2.0 * ch_y;
	wr.w_ll.w_x = p1->w_x;
	wr.w_ll.w_y = p1->w_y - 0.02;
	wr.w_ur.w_x = (p1 + 1)->w_x;
	wr.w_ur.w_y = (p1 + 1)->w_y +0.02;
	flagslocal();
	fadearea(&wr, 0);
	flagsglobal();
	polyline(2, p1);
}

areaatt()
{
	Wc p[4];
	p3 = &p[0];
	p3->w_x = 0.32; p3->w_y = 0.21; p3++;
	p3->w_x = 0.40; p3->w_y = 0.21; p3++;
	p3->w_x = 0.40; p3->w_y = 0.01 + 4.0 * ch_y; p3++;
	p3->w_x = 0.32; p3->w_y = 0.01 + 4.0 * ch_y; 
	s_fa_i(0);
	flagslocal();
	fillarea(4, &p[0]);
	flagsglobal();
	fillarea(4, &p[0]);
}

markatt()
{
	Wc p1;
	Wrect wr;
	wr.w_ll.w_x = 0.41; wr.w_ll.w_y = 0.01 + 4.0 * ch_y;
	wr.w_ur.w_x = 0.54; wr.w_ur.w_y = 0.218;
	fadearea(&wr, 0);
	p1.w_x = 0.47;
	p1.w_y = (0.22 + 0.01 + 4.0 * ch_y) / 2.0;
	flagsglobal();
	polymark(1, &p1);
}

textatt()
{	Wc p1;
	Wrect wr;
	String str;
	Tprec tp;
	wr.w_ll.w_x = 0.53;  wr.w_ll.w_y = 0.005 + 4.0 * ch_y;
	wr.w_ur.w_x = 0.728; wr.w_ur.w_y = 0.217;
	fadearea(&wr, 0);
	p1.w_x = 0.55;
	p1.w_y = 0.01 + 4.0 * ch_y;
	str = "A";
	tp = gkss->gk_txfp.fp_pr;
	if (tp != STR) {
		fp.fp_pr = STR;
		s_tx_fp(fp);
		text(str, &p1);
		fp.fp_pr = tp;
		s_tx_fp(fp);
	}
	else	text(str, &p1);
}

showupvector(vis)
Bool	vis;
{	Wc	p1[2];
	Real	x, y, z, l;
	String	str;
	Wrect	wtmp;

	ASS(wtmp, wr_upv)
	wtmp.w_ll.w_y -= (ch_y + 0.02);
	showwrect(&wtmp, 0);
	if (vis == TRUE) {
		showwrect(&wr_upv, 1);
		x = gkss->gk_chup.w_x;
		y = gkss->gk_chup.w_y;
		z = sqrt((double)(x*x + y*y));
		x = x / z;
		y = y / z;
		x = x * ((wr_upv.w_ur.w_x - wr_upv.w_ll.w_x) / 2.0);
		y = y * ((wr_upv.w_ur.w_y - wr_upv.w_ll.w_y) / 2.0);
		l = (wr_upv.w_ur.w_x - wr_upv.w_ll.w_x) / 8.0;
		p1[0].w_x = (wr_upv.w_ll.w_x + wr_upv.w_ur.w_x) / 2.0;
		p1[0].w_y = (wr_upv.w_ll.w_y + wr_upv.w_ur.w_y) / 2.0;
		p1[1].w_x = p1[0].w_x + x * 0.9; 
		p1[1].w_y = p1[0].w_y + y * 0.9; 
		flagslocal();
		if (inq_gks(gkss, gk_line) != 1) s_pl_i(1);
		polyline(2, p1);

		p1[0].w_y = p1[1].w_y;
		if (x > 0.0) p1[0].w_x = p1[1].w_x - l;
		else         p1[0].w_x = p1[1].w_x + l;
		polyline(2, p1);

		p1[0].w_x = p1[1].w_x;
		if (y > 0.0) p1[0].w_y = p1[1].w_y - l;
		else         p1[0].w_y = p1[1].w_y + l;
		polyline(2, p1);
		flagsglobal();
	}
	if (gkss->gk_txfp.fp_pr == CHAR)
		str = "CHAR";
	else	str = "STR";
	p1[0].w_x = wr_upv.w_ll.w_x + 0.006;
	p1[0].w_y = wr_upv.w_ll.w_y - ch_y;
	flagslocal();
	text(str, p1);
	flagsglobal();
}

showchoice(wr_nr, txnr)
Int wr_nr;
Int txnr;
{
	Wc wc;
	String tx;
	s_tx_i(1);
	if (txnr < 19) tx = primstr[txnr];
	else if (txnr == 27 || txnr == 28) tx = textat[txnr - 27];
	else		tx =  segmtx[txnr - 19];
	flagslocal();
#ifndef WITHOUTBOX
	showwrect(&wrect[wr_nr], 1);
#endif
	wc.w_x = wrect[wr_nr].w_ll.w_x + 0.01;
	wc.w_y =(wrect[wr_nr].w_ll.w_y+wrect[wr_nr].w_ur.w_y) * 0.5
			- ch_y * 0.3;
	flagslocal();
	text(tx, &wc);
	flagsglobal();
}

set_reps(wss_aed)
register Wss	*wss_aed;
{
	register Int i;
	register Real pi2 = 6.282;
	AreaRep	fa;
	MarkRep	mr;
	LineRep	lr;
	TextRep	tr;

	lr.lr_lt = SOLIDL;
	lr.lr_lw = 2.0;
	lr.lr_ci = 0;
	lr.lr_ix = 0;
	pl_rep(wss_aed, &lr);
	lr.lr_ci = 1;
	lr.lr_ix = 1;
	pl_rep(wss_aed, &lr);
	lr.lr_ci = 45;
	lr.lr_ix = 45;
	pl_rep(wss_aed, &lr);

	tr.tx_fp.fp_fo = 1;
	tr.tx_fp.fp_pr = STR;
	tr.tx_ci = 0;
	tr.tx_chef = 1.0;
	tr.tx_ix =  0 ; tx_rep(wss_aed, &tr);
	tr.tx_ci = 1;
	tr.tx_ix =  1 ; tx_rep(wss_aed, &tr);

	mr.mr_mt = MTDOT;
	mr.mr_ms = 1.0;
	mr.mr_ci = 0;
	mr.mr_ix =  0 ; pm_rep(wss_aed, &mr);
	mr.mr_ci = 1;
	mr.mr_ix =  1 ; pm_rep(wss_aed, &mr);
	mr.mr_mt = MTPLUS;
	mr.mr_ix =  2 ; pm_rep(wss_aed, &mr);
	mr.mr_mt = MTASTERISK;
	mr.mr_ix =  3 ; pm_rep(wss_aed, &mr);
	mr.mr_mt = MTCIRCLE;
	mr.mr_ix =  4 ; pm_rep(wss_aed, &mr);
	mr.mr_mt = MTCROSS;
	mr.mr_ix =  5 ; pm_rep(wss_aed, &mr);

	stringtx = strtx;

	col_rep(wss_aed, 0, &bg_col);
	col_rep(wss_aed, 1, &green);
	col_rep(wss_aed, 2, &green);
/*
#ifndef PET_RUBBERBAND
	for (i=3; i<250; i++) {
		col.c_red   = (sin(i*pi2 / 255.0) + 1.0) / 2.0;
		col.c_green = (sin(i*pi2 / 255.0 +pi2/3.0)+1)/2.0;
		col.c_blue  = (sin(i*pi2 / 255.0+2*pi2/3.0)+1)/2.0;
		col_rep(wss_aed, i, &col);
	}
#else
*/
	for (i=3; i<127; i++) {
		col.c_red   = (sin(i*pi2 / 127.0) + 1.0) / 2.0;
		col.c_green = (sin(i*pi2 / 127.0 +pi2/3.0)+1)/2.0;
		col.c_blue  = (sin(i*pi2 / 127.0+2*pi2/3.0)+1)/2.0;
		col_rep(wss_aed, i, &col);
	}
	col.c_red = col.c_green = col.c_blue = 0.8;
	for (i=128; i<256; i++) {
		col_rep(wss_aed, i, &col);
	}
/*
#endif
*/

	fa.fa_is = SOLID;
	for (i=3; i<250; i++) {
		fa.fa_ci = fa.fa_ix = i;
		fa_rep(wss_aed, &fa);
	}

	fa.fa_ci = 0;
	fa.fa_is = SOLID;
	fa.fa_ix =  0 ; fa_rep(wss_aed, &fa);
	fa.fa_is = HOLLOW;
	fa.fa_ix =  3 ; fa_rep(wss_aed, &fa);
	fa.fa_ci = 1;
	fa.fa_is = HOLLOW;
	fa.fa_ix =  1 ; fa_rep(wss_aed, &fa);
	fa.fa_is = SOLID;
	fa.fa_ix =  2 ; fa_rep(wss_aed, &fa);

}

sh_pol_att()
{
  	if (lastattshown == 0 &&
	   wss_aed->ws_wsd->wd_screen->s_colr)
		showcolours();
	if (lastattshown != k) {
		fadearea(&wrectot,0);
		showlinetypes();
		s_vip(gkss->gk_ntran[9], gkss->gk_ntran[8], FALSE);
		lastattshown = k;
  	}
}

sh_fill_att()
{
  	if (lastattshown == 0) showcolours();
  	if (lastattshown != k) {
		fadearea(&wrectot,0);
		showfilltypes();
		s_vip(gkss->gk_ntran[10], gkss->gk_ntran[8], FALSE);
		lastattshown = k;
  	}
}

sh_pom_att()
{
  	if (lastattshown == 0) showcolours();
  	if (lastattshown != k) {
		fadearea(&wrectot,0);
		showmarktypes();
		showsize(&wrect[11], 0.2);
		s_vip(gkss->gk_ntran[11], gkss->gk_ntran[8], FALSE);
		s_vip(gkss->gk_ntran[12], gkss->gk_ntran[8], FALSE);
		lastattshown = k;
	}
}

sh_text_att()
{
	if (lastattshown == 0) showcolours();
  	if (lastattshown != k) {
		fadearea(&wrectot,0);
		showfonttypes();
		showsize(&wrect[13], gkss->gk_chef/2.0);
		showsize(&wrect[14], gkss->gk_chht/0.08);
		showchoice(28, 28);
		showchoice(27, 27);
		s_vip(gkss->gk_ntran[13], gkss->gk_ntran[8], FALSE);
		s_vip(gkss->gk_ntran[14], gkss->gk_ntran[8], FALSE);
		s_vip(gkss->gk_ntran[15], gkss->gk_ntran[8], FALSE);
		s_vip(gkss->gk_ntran[28], gkss->gk_ntran[8], FALSE);
		s_vip(gkss->gk_ntran[29], gkss->gk_ntran[8], FALSE);
		lastattshown = k;
	}
}

ask_sn(segnm)
Segname	*segnm;
{
	Int s;
	Bool name_ok = FALSE;
	char cc[64];
	String str;
	while(name_ok == FALSE)
	{
	   str = cc;
	   str ="";
	   s_tx_i(1);
	   flagslocal();
	   init_str(wss_aed,1,str,1,&drecttx,&drectx);
	   req_str(wss_aed, 1 , stringtx);
	   flagsglobal();
	   i = 0;
	   s = 0;
	   while(i != strlen(stringtx) && stringtx[i] <= '9'
	   	&& stringtx[i] >= '0') {
			s *= 10;
			s += stringtx[i] - '0';
	   		i++;
	   }
	   if (i == strlen(stringtx)) name_ok = TRUE;
	   else comment(c[49], c[0], c[0], c[0]);
	}
	*segnm = (Segname)s;
}

s_pc(i, ch_y)
Int	i;
Real	ch_y;
{
	pc[i].w_x = 0.01;
	pc[i].w_y = 0.01 + (4 - i) * ch_y;
}

s_dev(nr, r)
Int	nr;
Real	r;
{	dev[nr] = (wrect[nr].w_ur.w_y - wrect[nr].w_ll.w_y) / r;
}

Real
s_raty(wc, i)
Wc	*wc;
Int	i;
{
	return ((wc->w_y - wrect[i].w_ll.w_y)/
		(wrect[i].w_ur.w_y - wrect[i].w_ll.w_y));
}
