	implicit integer (a-z)
c
c	Programma to read tar tapes on VAX/VMS
c	written by Jan Derksen
c
	character*512 blok, verbose*1, interactive*1
	character*100 dir, defdir, filnam
	logical posit
c
	common /tape/ ib, nb, chan
	common /ctape/ blok(20), verbose, dir, interactive
c
	defdir(1:100) = ' '
	is = sys$assign( 'TAPE', chan,,)
	if ( .not. is ) goto 1100
	nb = geti( 'Blockingsfactor : ' )
	ib = nb
	write(6,32)
32	format( ' Verbose? (y/n/s): ', $ )
	read(5,34) verbose
	if ( verbose .eq. 'j' ) verbose = 'y'
	write(6,33)
33	format( ' Interactive? (y/n): ', $ )
	read(5,34) interactive
	if ( interactive .eq. 'j' ) interactive = 'y'
34	format(a)
c
10	continue
	call getnam( defdir, dir, filnam )
	ld = index( dir, ' ' ) - 1
	lf = index( filnam, ' ' ) - 1
	if ( filnam(1:1) .eq. '*' ) then
	  call resdir( )
	else
	  if ( .not. posit( dir(1:ld)//filnam(1:lf) ) ) then
	    type *,' File not found on tape.'
	    call exit
	  end if
	  call restor( filnam(1:lf) )
	end if
	goto 10
c
1100	print 1101, is
1101	format(' tape assignment failure, status =',z8)
	end
	integer function geti( s )
	character*(*) s
	character*10 answer
	logical lib$get_command, for$cnv_in_i
10	if ( lib$get_command( answer, s ) ) then
	 j = index(answer,' ') - 1
	 if ( .not. for$cnv_in_i( answer(1:j), geti ) ) goto 2000
	else
	 type *,' failure in lib$get_command'
	end if
	return
2000	type *,' conversion error.'
	goto 10
	end
c
	logical function xrew( chan )
	implicit integer (a-z)
	logical sys$qiow
	external io$_rewind
	iof = %loc( io$_rewind )
	xrew = sys$qiow(,%val(chan),%val(iof),,,,,,,,,)
	return
	end
c
	logical function xskipf( chan, nfile )
	implicit integer (a-z)
	logical sys$qiow
	external io$_skipfile
	iof = %loc( io$_skipfile )
	xskipf = sys$qiow(,%val(chan),%val(iof),,,,%val(nfile),,,,,)
	return
	end
c
	logical function xskipr( chan, nrec )
	implicit integer (a-z)
	logical sys$qiow
	external io$_skiprecord
	iof = %loc( io$_skiprecord )
	xskipr = sys$qiow(,%val(chan),%val(iof),,,,%val(nrec),,,,,)
	return
	end
c
	logical function xread( chan, buf, bc )
	implicit integer (a-z)
	character*512 blok, verbose*1, interactive*1, dir*100
	integer*2 iosb(4)
	logical sys$qiow
	external io$_readvblk
	common /ctape/ blok(20), verbose, dir, interactive
c
	f = %loc( io$_readvblk )
	xread = sys$qiow(,%val(chan),%val(f),iosb,,,buf,%val(bc),,,,)
        if ( verbose .eq. 's' )then
		print 1, iosb
1		format(1x,4z12)
	endif
	if ( .not. xread ) return
	xread = iosb(1)
	return
	end
c
	logical function posit( string )
	implicit integer (a-z)
	logical linkflag
	external ss$_endoffile
	character*(*) string
	character*512 blok, verbose*1, interactive*1, dir*100
c
	common /tape/ ib, nb, chan
	common /ctape/ blok(20), verbose, dir, interactive
c
	type *,' posit on ',string
10	ib = ib + 1
	if ( ib .gt. nb ) then
c .. read next block.
		is = xread( chan, %ref(blok), nb*512 )
		if ( is .eq. %loc(ss$_endoffile) ) then
			posit = .false.
			return
		end if
		ib = 1
	end if
	if ( string .eq. blok(ib)(1:len(string)) ) then
		posit = .true.
		return
	else
		lnam = index( blok(ib), char(0) )
		linkflag = blok(ib)(157:157) .ne. char(0)
		if ( linkflag ) linknam = index(blok(ib)(158:257), char(0))
		if ( verbose .eq. 'y' ) then
		  if ( linkflag ) then
		    type *,blok(ib)(1:lnam-1),' linked to ',
     *		           blok(ib)(158:156+linknam)
		  else
		    type *,blok(ib)(1:lnam-1)
		  end if
		end if
	end if
c skip blocks of file
	if ( linkflag ) then
	  nbyt = 0
	else
	  nbyt = getsiz()
	end if
	nblk = (nbyt+511)/512
	if ( nblk .gt. 0 ) then
		do 100 i = 1, nblk
			if ( .not. nxtblk( dum ) ) return
100		continue
	end if
	goto 10
c
	end
c
	subroutine restor( filnam )
	implicit integer (a-z)
	logical nxtblk
	character*(*) filnam
c	max: 9+1+3
        character*128 filename
	character*128 orgnam
	character*512 blok, verbose*1, interactive*1, dir*100
	character*1024 record
c
	common /tape/ ib, nb, chan
	common /ctape/ blok(20), verbose, dir, interactive
c
	nbytes = getsiz( dum )
	nkb = (nbytes+1023)/1024
	print 1, nkb
1	format(1x,i3,' Kb')
c
	close( unit=10 )
	lnam = len(filnam)
	orgnam(1:lnam) = filnam
	call vmsnam( filename, filnam )
	lfnam = index( filename, ' ' ) - 1
50	open( unit=10, name=filename,carriagecontrol='list',
     *        type='new', err=3001 )
	lrest = 0
	nrec = 0
100	if ( .not. nxtblk( dum ) ) then
	  type *,' End of file during restore.'
	  call exit
	end if
c
c ... search line feed .
	j = index( blok(ib), char( 10 ) )
	if ( j .eq. 0 ) then
	 type *, '             ***** line feed not found.'
	 j = 513
	end if
	if ( lrest .gt. 0 ) then
	 record(lrest+1:1024) = blok(ib)(1:j-1)
	 lrec = lrest + j - 1
	 call outrec( 10, record, lrec, nrec )
	 lrest = 0
	else
	 lrec = j - 1
	 call outrec( 10, blok(ib)(1:lrec), lrec, nrec )
	end if
	nbytes = nbytes - lrec - 1
	if ( (nbytes+1023)/1024 .ne. nkb ) then
	  print 99, nkb
99	  format(1h+,i3)
	  nkb = (nbytes+1023)/1024
	end if
	if ( nbytes .le. 0 ) goto 2000
c
c ... treat rest of block
200	ic = j + 1
	if ( ic .gt. 512 ) goto 100
	j = index( blok(ib)(ic:512), char( 10 ) )
	if ( j .gt. 0 ) then
	 j = j + ic - 1
	 lrec = j - ic
	 call outrec( 10, blok(ib)(ic:j-1), lrec, nrec )
c	 write(10,101,err=2100) blok(ib)(ic:j-1)
         nbytes = nbytes - lrec - 1
	 if ( (nbytes+1023)/1024 .ne. nkb ) then
	    print 99, nkb
	    nkb = (nbytes+1023)/1024
	 end if
	 if ( nbytes .le. 0 ) goto 2000
	 goto 200
	else
	 lrest = 513 - ic
	 record(1:lrest) = blok(ib)(ic:512)
	 goto 100
	end if
2000	write(6,2001) orgnam(1:lnam), filename(1:lfnam), nrec
2001	format(' file :',a,' restored as :',a,i10,' records.')
	return
3001	write(6,3002) orgnam(1:lnam), filename(1:lfnam)
3002    format(' unix filename was :',a,' vms filename is :',a/
     *         ' could not be opened, give new file name:'$)
	read(5,3003) filename
3003    format(a)
	goto 50
	end
c
	subroutine vmsnam( vname, uname )
	character *(*) uname
	character *128 vname
	character c
c
	vname = '             '
	l = len( uname )
c
c modify directoryname
	i = 1
	k = 1
100	j = index( uname(i:l), '/' )
	if ( j .eq. 0 ) goto 120
	if ( k .eq. 1 ) then
	  vname(1:1) = '['
	  k = 2
	end if
	j = j + i - 2
	vname(k:k+j-i+1) = '.'//uname(i:j)
	k = k + j - i + 2
	i = j + 2
	goto 100
120	if ( k .gt. 1 ) then
	  vname(k:k) = ']'
	  k = k + 1
	end if
	if ( l-i+1 .gt. 13 ) l = i+12
	if ( l - 4 .ge. i ) then
	 do 130 j = i, l-4
	  if ( uname(j:j) .eq.  '.' ) uname(j:j) = 'p'
130	 continue
	end if
	j = index(uname(i:l),'.')
	if ( j .eq. 0 ) then
	  if ( l-i .gt. 8 ) then
	     l = i + 9
	  else
	    l = l + 1
	  endif
	  uname(l:l) = '.'
	else
	  j = j + i - 1
	  if ( j - i .gt. 9 ) then
	    l = i + 9
	    uname(l:l) = '.'
	  end if
	endif
	vname(k:k+l-i+1) = uname(i:l)
	l = k + l - I + 1
c
c change underlines & hyphens
	do 20 i = 1, l
	  if ( vname(i:i) .eq. '_' ) vname(i:i) = 'u'
	  if ( vname(i:i) .eq. '-' ) vname(i:i) = 'm'
20	continue
	vname(l:) = ' '
	end
c
	subroutine outrec( unit, rec, l, nrec )
	implicit integer (a-z)
	character*(*) rec
c
	 lrec = l
	 jr = 0
110	 if ( lrec .gt. 130 ) then
	  write(unit,101,err=2100) rec(jr+1:jr+130)
	  type *,'               record :',nrec+1,' splitted !'
	  nrec = nrec + 1
	  jr = jr + 130
	  lrec = lrec - 130
	  goto 110
	 end if
	 if ( lrec .gt. 0 ) then
		write(unit,101,err=2100) rec(jr+1:jr+lrec)
		nrec = nrec + 1
         end if
101	 format(a)
	return
2100	write(6,2101) nrec, l
2101    format(' Failure in record :',i5,' lrec =',i5)
        call exit
	end
	subroutine getnam( defdir, dir, filnam )
c
c  read a file specification.
c  if there is a part of a directory, copy it to the
c  current default directory ( defdir ), else copy defdir to dir.
c
c
	character*100 defdir, dir, filnam
c
	dir = ' '
	if ( lib$get_command( filnam, 'UNIX file spec  : ' ) ) then
	 j = index( filnam, ' ' ) - 1
	 if ( j .le. 0 ) call exit
	 ld = index( filnam(1:j), '/' )
	 if ( ld .gt. 0 ) then
30	  kd = index( filnam(ld+1:j), '/' )
	  if ( kd .le. 0 ) goto 60
	   ld = ld + kd
	   goto 30
60	  defdir(1:100) = filnam(1:ld)
          filnam = filnam(ld+1:j)
	 else
c ..  no directory, so take the default
	  ld = index( defdir, ' ' ) - 1
	  if ( ld .le. 0 ) then
c	   type *, 'no default directory!'
c	   call exit
	  end if
	 end if
	 dir(1:ld) = defdir(1:ld)
	end if
c
	return
	end
	logical function nxtblk( dum )
	implicit integer (a-z)
	character*512 blok, verbose*1, interactive*1, dir*100
	external ss$_endoffile
c
	common /tape/ ib, nb, chan
	common /ctape/ blok(20), verbose, dir, interactive
c
	ib = ib + 1
	nxtblk = .true.
	if ( ib .gt. nb ) then
	 is = xread( chan, %ref(blok), 512*nb )
	 nxtblk = is .ne. %loc( ss$_endoffile )
	 if ( nxtblk ) ib = 1
	end if
c
	return
	end
	subroutine resdir( )
	implicit integer (a-z)
	logical posit, nxtblk
	character filnam*100, blok*512, newfil*25, verbose*1, dir*100
c
	common /tape/ ib, nb, chan
	common /ctape/ blok(20), verbose, dir, interactive
c
	ld = index( dir, ' ' ) - 1
10	if ( .not. posit( dir(1:ld) ) ) then
	  type *,' Directory not found.'
	  call exit
	end if
c  controleer of dit geen subdirectory is.
c	lf = index( blok(ib)(ld+1:512), char( 0 ) ) - 1
c	if ( index( blok(ib)(ld+1:ld+lf), '/' ) .gt. 0 ) goto 10
c
100	continue
	  lf = index( blok(ib)(ld+1:512), char( 0 ) ) - 1
	  filnam(1:lf) = blok(ib)(ld+1:ld+lf)
	  if ( lf .eq. 0 .or. filnam(lf:lf) .eq. '/' ) goto 110
	  if ( interactive .eq. 'y' .or.
     *         blok(ib)(157:157) .ne. char(0) ) then
	    write(6,101) filnam(1:lf)
101	    format(' restore file :',a,' ? (y/n)'$)
	    read(5,102) newfil
102	    format(a)
	    if ( newfil(1:1) .eq. 'n' ) then
c    skip deze file.
110	        if ( blok(ib)(157:157) .eq. char(0) ) then
                 if ( for$cnv_in_o( blok(ib)(125:135), nbyt ) ) then
	          nbl = ( nbyt + 511 ) / 512
		  if ( nbl .eq. 0 ) goto 200
	          do 120 ibl = 1, nbl
	            if ( .not. nxtblk( dum ) ) goto 2000
  120	       	  continue
	         else
	          type *,' Conversion error in bytecount.'
	          call exit
	         end if
		end if
		goto 200
	    else
c   restore this file, eventually with an new name
	      write(6,'('' VMS-filename :'')')
	      read(5,'(a)') newfil
	      j = index( newfil, ' ' ) - 1
	      filnam(1:j) = newfil(1:j)
	      lf = j
	    end if
	  end if
	  if ( filnam(lf-1:lf) .eq. '.o' ) then
	    write(6,103) filnam
103	    format(1x,a,' can not restor .o files ....')
	    goto 110
	  end if
	  call restor( filnam(1:lf) )
c
200	  if ( nxtblk( dum ) ) then
c  same directory ??
	    if ( blok(ib)(1:ld) .eq. dir ) goto 100
	  end if
c
2000	return
	end
	integer function getsiz( dum )
	implicit integer (a-z)
	character blok*512, verbose*1, dir*100
	logical for$cnv_in_o
c
	common /tape/ ib, nb, chan
	common /ctape/ blok(20), verbose, dir, interactive
c
	if ( .not. for$cnv_in_o( blok(ib)(125:135), number ) ) then
		type *,' Conversion error in getsiz'
		type *,' string was :',blok(ib)(125:135)
		type *,' ib =',ib
		call exit
	end if
	getsiz = number
	return
	end



