/* @(#) aedgdp.h  version:1.6  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.aedgdp.h
 * SCCS id :	aedgdp.h 1.6
 * Last edited:	10/19/84 14:09:43
 */

/*This file contains driver functions and driver utility functions
 *for the AED */


STATIC
Bool
gendrawpr(ws, id, n, ic, lrep, mrep, trep, frep, m, gdr)
Wss	*ws;
Gdpi	id;
Size	n, m;
Ic	*ic;
LineRep	*lrep;
MarkRep	*mrep;
TextRep	*trep;
AreaRep	*frep;
Grecord	*gdr;
{	register Int i;
	Int	x, y, rad;
	Screen	*scr = WsScrn;

	/* AED can't make circles with radius
	 * larger than 0177 
	 * ???
	 */
	Set_Out(ws->ws_ofile);

	switch (id) {
	case CIRCLE:
		if ((atbeam(ic) == FALSE) || graphmode == TRUE)
			moveto(ic);
		x = ic[1].i_x - ic[0].i_x;
		y = ic[1].i_y - ic[0].i_y;
		rad = sqrt((double)(x * x + y * y));

		if (rad != 0) {
			if (scr->s_colr) 
				(*scr->s_colr)(ws, frep->fa_ci);

			switch (frep->fa_is) {
			case  HOLLOW:
				alphamode();
				prefix(ESC);
				command(AedDCL);
				value8(rad);
				/*the radius must be one byte */
			break;
			case SOLID:
				alphamode();
				prefix(ESC);
				for (i = rad; i != 0; i--) {
					command(AedDFC);
					value8(i);
					/*the radius must be one byte */
				}
			break;
			default:
			break;
			}
		}
	break;
	default:
	break;
	}
}
