/* @(#) aedhili.h  version:1.6  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.aedhili.h
 * SCCS id :	aedhili.h 1.6
 * Last edited:	11/13/84 14:11:30
 */

#define	HILI_CIX 254
#define	SLEEPTIME 1


/* draw pixels temporarily in colour HILI_CIX;
 * set hilightning on for some time;
 * redraw pixels in original colours.
 */

STATIC
Bool
hilight(ws, n, ic)
Wss	*ws;
Int	n;
Ic	*ic;
{
	register Int i, j, k;
	register Cindex *cixptr;
	Ic	s2, *ic2;
	Cindex 	*oldcix;
	Int	horpx , verpx ;

	Set_Out(ws->ws_ofile)

	if (n == 1)	 horpx = verpx = 4;
	else if (n < 4)  horpx = verpx = 3;
	else if (n < 10) { horpx = 3; verpx = 2; }
	else 		 horpx = verpx = 2;

	/*to prevent a long delay: */
	if (n > 30) n = 30;

	aedhili(10, 10);

	/*store current colours of n rects and 
	 *redraw all points with colour HILI_CIX 
	 */
	CALLOC(oldcix, Cindex, (n*horpx*verpx), SCR_ROUT)
	cixptr = oldcix;
	setcol(ws, HILI_CIX);
	ic2 = ic;
	prefix(ESC);
	for (i = 0; i < n; i++) {
		for (j = 0; j < horpx; j++) 
		for (k = 0; k < verpx; k++) {
			s2.i_x = ic2->i_x + j;
			s2.i_y = ic2->i_y + k;
			rdpixel(ws, &s2, cixptr);
			cixptr++;
		}
		ic2++;
	}
	ic2 = ic;
	for (i = 0; i < n; i++) {
		command(AedMOV);
		abscoord(ic2);
		command(AedDFR);
#if	(CODE == 1)
		fprintf(AedOUT,"%d %d ",
			ic2->i_x + horpx - 1, ic2->i_y + verpx - 1);
#endif
		ic2++;
	}
	fflush(AedOUT);
	sleep(SLEEPTIME);

	/*redraw points in origional colour*/
	cixptr = oldcix;
	ic2 = ic;
	prefix(ESC);
	for (i = 0; i < n; i++) {
		for (j = 0; j < horpx; j++) 
		for (k = 0; k < verpx; k++) {
			command(AedMOV);
#if	(CODE == 1)
			fprintf(AedOUT,"%d %d ", ic2->i_x+j,ic2->i_y+k);
#endif
			command(AedWPX);
			value8(*cixptr);
			cixptr++;
		}
		ic2++;
	}
	fflush(AedOUT);
	FREE(oldcix)

	/*set hilightning off:*/
	aedhili(0, 0);
}

aedhili(period1, period2)
Int	period1, period2;
{
	/*set hilightning on */
	prefix(ESC);
	command(AedSBL);
	value8(HILI_CIX); /*color*/
	value8(200); /*r*/
	value8(0); /*g*/
	value8(0); /*b*/
	value8(period1); /*on.time*/
	value8(period2); /*off.time*/
}
