/* @(#) aedpix.h  version:1.16  dated:84/12/19 */
/*
 * SCCS file:	SCCS/s.aedpix.h
 * SCCS id :	aedpix.h 1.16
 * Last edited:	12/19/84 13:40:45
 */

/*This file contains driver functions and driver utility functions
 *for the AED concernig pixel facilities*/

Bool	rdpixel();
Bool	getvalue8();
Bool	getaedint();

/*
 * the di/dd interface function aedrle(), entry s_runl,
 * writes run length encoded sequences to aed512
 */
Bool
aedrle(ws, icb, nr, runs, cols)
Wss	*ws;
Ic	*icb;
Int	nr, *runs;
Cindex 	*cols;
{
	Int i, px_nr;

	Set_Out(ws->ws_ofile)

	moveto(icb);
	command(AedWHU);
	for (i = 0; i < nr; i++) {
		px_nr = *runs++;
		while (px_nr > 254) {
			value8(254);
			value8(*cols);
			px_nr -= 254;
		}
		value8(px_nr);
		value8(*cols++);
	}
	value8(0);
}


/*inqpixels() gets pixelvalues from area starting at (dx, dy)
 *in upperleft corner, and with sizes ix by iy.
 *Values are returned in ci.
 *The following functions does not work yet on 9600
 *with larg ix and iy.
 */
STATIC
Bool
inqpixels(ws, ix, iy, dx, dy, inv, ci)
Wss	*ws;
int	ix, iy;
Int	dx, dy;
Bool	*inv;
Cindex	*ci;
{
	Ic	s;
	Bool	ret;

	Set_In (ws->ws_ifile);
	Set_Out(ws->ws_ofile);
	if (dx == 1 && dy == 1) { /*pixel()*/
		s.i_x = (Int)ix;
		s.i_y = (Int)iy;
		ret= rdpixel(ws, &s, ci);
	}
	else if (dx != 0 && dy != 0) { /*this fun used for pxl_arr()*/
		Int 	i, lngth, ll = 0, rr = 0 , uu = 0;
		Ic	ulcl, lrcl;
		Cindex	*ci2;
		Cindex	cix;
		Int	nr;
		Ic	*size = &(WsScrn)->s_size;

		/*calculate ulcl and lrcl: */
		if (ix < 0) {
			ulcl.i_x = 0;
			ll = -ix;
		}
		else ulcl.i_x = ix;
		if (iy > size->i_y) {
			ulcl.i_y = size->i_y; 
			uu = iy - size->i_y;
		}
		else 	ulcl.i_y = iy;
		if (iy - (int)dy + 1 < 0) {
			lrcl.i_y = 0;
			/*
			dd = -(iy - (int)dy + 1);
			*/
		}
		else 	lrcl.i_y = iy - (int)dy + 1;
		if (ix + (int)dx - 1 > size->i_x) {
			lrcl.i_x =  size->i_x;
			rr = ix + (int)dx - 1 - size->i_x;
		}
		else 	lrcl.i_x = ix + (int)dx - 1;

		/*
		prefix(ESC);
		command(AedSTD);
		value8(4);
		*/

		moveto(&ulcl);
		command(AedDAI);
		abscoord(&lrcl);
		command(AedRHR);

#if 	(CODE == 1)
		ci2 = ci;
		ci2 += uu * dx + ll;
		lngth = dx - ll - rr;
		/*aed returns the runlenghts of each colour,
		 *followed by the colour.  nr = 0 stops the sequence.
		 *It does not work properly on 9600 bd (loss of
		 *information).
		 */
		do {
			while (getaedint(&nr) == FALSE) ;
			if (nr != 0) {
				getaedint(&cix);

				i = nr;
				while (i-- != 0) {
					if (lngth == 0) {
						ci2 += ll + rr;
						lngth = dx - rr - ll;
					}
					*ci2++ = cix;
					lngth--;
				}
			}
		} while (nr != 0);
#endif
		ret = TRUE;
	}
	return(ret);
}

Bool
rdpixel(ws, s, cix)
Wss	*ws;
Ic	*s;
Cindex	*cix;
{
	moveto(s);
	prefix(ESC);
	command(AedRPX);
	return (getvalue8((int *)cix));
}

Bool
getaedint(x)
int *x;
{
	char	resp[12];
	register char *cp, *cp10;

	cp10 = &resp[10];
	cp = resp;

	while ((isdigit(*cp = fgetc(AedIN))) && cp < cp10)
		cp++;
	*cp = '\0';

	return((Bool)(sscanf(resp,"%d",x) == 1));
}

/* get one byte , followed by a '\n' */
Bool
getvalue8(x)
int *x;
{
	int	ret;
	char	resp[12];
	register char *cp, *cp10;

	cp10 = &resp[10];
#if (CODE == 1)
	cp = resp;
	while ((*cp = fgetc(AedIN)) != '\n' && cp < cp10)
		cp++;
	*cp = '\0';
	return ((Bool) (sscanf(resp,"%d",x) >= 1));
#endif
#if (CODE == 7)
#endif
#if (CODE == 8)
#endif
}
