/* @(#) cgkslevel.h  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.cgkslevel.h
 * SCCS id :	cgkslevel.h 1.5
 * Last edited:	10/19/84 14:02:37
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 * Define the level of the GKS implementation of the library
 * you want to create.
 * A higher level will result in a larger library.
 * This level setting is only usefull during creation of the library;
 * during compilation of an application program those (and only
 * those) modules are taken from the library that are called by the 
 * application.
 *
 * GKSOUTP_LEV  can have values 0, 1 and 2
 * GKSINP_LEV   can have values 0, 1 and 2 standing for a, b and c
 */
#define	GKSINP_LEV	2	/* */
#define	GKSOUTP_LEV	2	/* */
