/* @(#) cgksmfit.h  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.cgksmfit.h
 * SCCS id :	cgksmfit.h 1.5
 * Last edited:	10/19/84 14:01:51
 *
 * Author:	Miente Bakker
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


#ifdef METAFILE

/*
	enumeration of item types for metafiles
							*/
#define M_CLWK		0	/*	end item	*/
#define M_CLRWK		1	/*	clear workstation	*/
#define M_RSGWK		2	/*	redraw all segments on w.s.	*/
#define M_UWK		3	/*	update w.s.	*/
#define M_SDS		4	/*	set deferral state	*/
#define M_MSG		5	/*	message	*/
#define M_ESC		6	/*	escape	*/

#define M_PL		11	/*	polyline	*/
#define M_PM		12	/*	polymarker	*/
#define M_TX		13	/*	text	*/
#define M_FA		14	/*	fill area	*/
#define M_CA		15	/*	cell array	*/
#define M_GDP		16	/*	general drawing primitive	*/

#define M_SPLI		21	/*	set polyline index	*/
#define M_SLN		22	/*	set line type	*/
#define M_SLWSC		23	/*	set linewidth scale factor*/
#define M_SPLCI		24	/*	set polyline colour index	*/

#define M_SPMI		25	/*	set polymarker index	*/
#define M_SMK		26	/*	set marker type		*/
#define M_SMKSC		27	/*	set marker size scale factor	*/
#define M_SPMCI		28	/*	set polymarker colour index	*/

#define M_STXI		29	/*	set text index	*/
#define M_STXFP		30	/*	set text font and precision	*/
#define M_SCHXP		31	/*	set character expansion factor	*/
#define M_SCHSP		32	/*	set character spacing	*/
#define M_STXCI		33	/*	set text colour index	*/
#define M_SCHUP		34	/*	set character up vector	*/
#define M_STXP		35	/*	set text path	*/
#define M_STXAL		36	/*	set text alignment	*/

#define M_SFAI		37	/*	set fill area index	*/
#define M_SFAIS		38	/*	set fill area interior style	*/
#define M_SFASI		39	/*	set fill area style index	*/
#define M_SFACI		40	/*	set fill area colour index	*/
#define M_SPA		41	/*	set pattern size	*/
#define M_SPARF		42	/*	set pattern reference point	*/
#define M_SASF		43	/*	set ASPECT SOURCE FLAGs	*/
#define M_SPKID		44	/*	set pick identifier	*/

#define M_SPLR		51	/*	set poyline representation	*/
#define M_SPMR		52	/*	set polymarker representation	*/
#define M_STXR		53	/*	set text representation	*/
#define M_SFAR		54	/*	set fill area representation	*/
#define M_SPAR		55	/*	set pattern representation	*/
#define M_SCR		56	/*	set colour representation	*/

#define M_SCLPR		61	/*	set clipping rectangle	*/
#define M_SWKWN		71	/*	set workstation window	*/
#define M_SWKVP		72	/*	set workstation viewport	*/

#define M_CRSG		81	/*	create segment	*/
#define M_CLSG		82	/*	close segment	*/
#define M_RENSG		83	/*	rename segment	*/
#define M_DSG		84	/*	delete segment	*/

#define M_SSGT		91	/*	set segment transformation	*/
#define M_SVIS		92	/*	set segment visibility	*/
#define M_SHLIT		93	/*	set segment highlighting	*/
#define M_SSGP		94	/*	set segment priority	*/
#define M_SDTEC		95	/*	set segment detectability	*/

#endif
